

#  ecc.defn.tcl     ECC VXI card
global  chansel


proc {AddECCModule}  {module slot}  {
   global registerbase cardtype nsockets

   set registerbase $cardtype#$module

   delete-vxi-registers $registerbase.*

   ECCVXIRegisters $slot
   ECCModuleRegisters $slot

   for {set socket 1} {$socket <= $nsockets} {incr socket} {
        set registerbase $cardtype[expr $module * $nsockets + $socket - 1]

        delete-vxi-registers $registerbase.*

#    first a register to record module each channel is in
       ecc_register  ModuleName    generic "-n$cardtype#$module -tstring -pro"
   
        ECCVXIRegisters $slot
        ECCModuleRegisters $slot

        set c 0
        foreach segment {A B C D} {
            set registerbase $cardtype[expr $module * $nsockets + $socket - 1].$segment
            ECCDetectorRegisters $slot $socket $c
            incr c
        }
   }
}


proc ecc_register {registername class attributes} {
   global registerbase
   define-vxi-register $registerbase $class $registername "$attributes"
}

proc ECCVXIRegisters {slot} {

  ecc_register  datal          xDig "-s$slot -o0x0 -w32 -prw -fx"
  ecc_register  dataw          xDig "-s$slot -o0x0 -w16 -prw -fx"
#  ecc_register  Shtdata        xSht "-s$slot -o0x0 -w16 -prw -fx"

  ecc_register  VXI.ManID      xSht   "-s$slot -o0  -pro -w16 -fx -b0  -l12"
  ecc_register  VXI.AddrSpace  xSht   "-s$slot -o0  -pro -w16 -fd -b12 -l2"
  ecc_register  VXI.DevClass   xSht   "-s$slot -o0  -pro -w16 -fd -b14 -l2"
  ecc_register  VXI.ModelCode  xSht   "-s$slot -o2  -pro -w16 -fx -b0  -l12"
  ecc_register  VXI.ReqMem     xSht   "-s$slot -o2  -pro -w16 -fd -b12 -l4"
  ecc_register  VXI.Reset      xSht   "-s$slot -o4  -prw -w16 -fd -b0  -l1"
  ecc_register  VXI.Passed     xSht   "-s$slot -o4  -pro -w16 -fd -b2  -l1"
  ecc_register  VXI.Ready      xSht   "-s$slot -o4  -pro -w16 -fd -b3  -l1"
  ecc_register  VXI.ModID      xSht   "-s$slot -o4  -pro -w16 -fd -b14 -l1"
  ecc_register  VXI.A24A32     xSht   "-s$slot -o4  -pro -w16 -fd -b15 -l1"
  ecc_register  VXI.Offset     xSht   "-s$slot -o6  -pro -w16 -fx"
  ecc_register  VXI.Control     xSht   "-s$slot -o4  -prw -w16 -fx -b0 -l0 -i0xffc0"
  ecc_register  VXI.SerialNum  xSht   "-s$slot -o8  -pro -w16 -fx"
  ecc_register  VXI.ModLevel   xSht   "-s$slot -o10 -pro -w16 -fx"
}


proc ECCModuleRegisters {slot} {
   global registerbase

#    common area registers

#    Common DACs  (12 bit)

       ecc_register Valid_Thresh      xDig "-s$slot -o0x00 -w16 -pwo -b0 -l12"
       ecc_register Addback_Thresh    xDig "-s$slot -o0x02 -w16 -pwo -b0 -l12"
       ecc_register TestGenAmpl       xDig "-s$slot -o0x04 -w16 -pwo -b0 -l12"
       ecc_register CFD.Width         xDig "-s$slot -o0x06 -w16 -pwo -b0 -l12"

#    Common registers

       ecc_register   MCR_analog              xDig    "-s$slot -o0x12 -w16 -prw -fx -b0 -l0"
       ecc_register   PileupReject            xDig    "-s$slot  -o0x12 -w16 -prw -fx -b0 -l1"
       ecc_register   VetoReject              xDig    "-s$slot  -o0x12 -w16 -prw -fx -b1 -l1"
       ecc_register   SynchroTestGenEnable    xDig    "-s$slot  -o0x12 -w16 -prw -fx -b2 -l1"
       ecc_register   SinglesReadoutEnable    xDig    "-s$slot  -o0x12 -w16 -prw -fx -b3 -l1 -i0"
       ecc_register   TACStopMode             xDig    "-s$slot  -o0x12 -w16 -prw -fx -b4 -l1 -i0"
       ecc_register   MultiplicityMode        xDig    "-s$slot  -o0x12 -w16 -prw -fx -b5 -l1"
       ecc_register   EEPROMWriteEnable       xDig    "-s$slot  -o0x12 -w16 -prw -fx -b6 -l1"
       ecc_register   OrMultiplicity          xDig    "-s$slot  -o0x12 -w16 -prw -fx -b7 -l1"
       ecc_register   CCLCode                 xDig    "-s$slot  -o0x12 -w16 -prw -fx -b8 -l3"

       ecc_register   MCR_GIR                 xDig    "-s$slot -o0x10 -w16 -prw -fx -b0 -l0 -i0"
       ecc_register   LastCard                xDig    "-s$slot  -o0x10 -w16 -prw -fx -b0 -l1"
       ecc_register   FIFO.Reset              xDig    "-s$slot  -o0x10 -w16 -prw -fx -b1 -l1"
	ecc_register   DSP.Reset               xDig    "-s$slot  -o0x10 -w16 -prw -fx -b2 -l1 -i0"
       ecc_register   ResetGIR                xDig    "-s$slot  -o0x10 -w16 -prw -fx -b3 -l1"

       ecc_register Simulate_CFD      xDig "-s$slot -o0x12 -w16 -pwo -b0 -l0"


       ecc_register   DSP.DAC.Adj             xDig "-s$slot -o0x14 -w16 -pwo -fx -b0 -l12 -i0x7FF"
       ecc_register   DSP.POT.Adj           xDig "-s$slot -o0x16 -w16 -pwo -fx -b0 -l8 -i0xFF"

       ecc_register Insp.D1.Channel   xMux "-s$slot -o0x20 -w16 -prw -b0 -l16 -dECC -md1"
       ecc_register Insp.D1.Signal    xDig "-s$slot -o0x22 -w16 -prw -fd -b0 -l0 -i0"
       ecc_register Insp.D2.Channel   xMux "-s$slot -o0x24 -w16 -prw -b0 -l16 -dECC -md2"
       ecc_register Insp.D2.Signal    xDig "-s$slot -o0x26 -w16 -prw -fd -b0 -l0 -i0"
       ecc_register Insp.A1.Channel   xMux "-s$slot -o0x28 -w16 -prw -b0 -l16 -dECC -ma1"
       ecc_register Insp.A1.Signal    xDig "-s$slot -o0x2a -w16 -prw -fd -b0 -l0 -i0"
       ecc_register Insp.A2.Channel   xMux "-s$slot -o0x2c -w16 -prw -b0 -l16 -dECC -ma2"
       ecc_register Insp.A2.Signal    xDig "-s$slot -o0x2e -w16 -prw -fd -b0 -l0 -i0"
       ecc_register Insp.V.Channel    xMux "-s$slot -o0x30 -w16 -prw -b0 -l16 -dECC -mv"
       ecc_register Insp.V.Signal     xDig "-s$slot -o0x32 -w16 -prw -fd -b0 -l0 -i0"

#   Temperature control registers  0x40 => 0x54

       ecc_register   GIR.TCR.ReadTemp 	xDig    "-s$slot  -o0x40 -w16 -pro -fx -b0 -l9"
       ecc_register   GIR.TCR.WriteTempHigh xDig    "-s$slot  -o0x42 -w16 -pwo -fx -b0 -l9 -i0x3c"
       ecc_register   GIR.TCR.WriteTempLow 	xDig    "-s$slot  -o0x44 -w16 -pwo -fx -b0 -l9 -i0x28"
       ecc_register   GIR.TCR.ReadTempHigh 	xDig    "-s$slot  -o0x46 -w16 -pro -fx -b0 -l9"
       ecc_register   GIR.TCR.ReadTempLow 	xDig    "-s$slot  -o0x48 -w16 -pro -fx -b0 -l9"
       ecc_register   GIR.TCR.ReadCounter 	xDig    "-s$slot  -o0x4A -w16 -pro -fx -b0 -l9"
       ecc_register   GIR.TCR.ReadSlope 	xDig    "-s$slot  -o0x4C -w16 -pro -fx -b0 -l9"
       ecc_register   GIR.TCR.StartConvert 	xDig    "-s$slot  -o0x4E -w16 -pwo -fx -b0 -l9"
       ecc_register   GIR.TCR.StopConvert 	xDig    "-s$slot  -o0x50 -w16 -pwo -fx -b0 -l9"
       ecc_register   GIR.TCR.ClearAlarm    xDig    "-s$slot  -o0x52 -w16 -pwo -fx -b5 -l2"
       ecc_register   GIR.TCR.ReadConfig.Low   xDig    "-s$slot  -o0x54 -w16 -pro -fx -b5 -l1 "
       ecc_register   GIR.TCR.ReadConfig.High  xDig    "-s$slot  -o0x54 -w16 -pro -fx -b6 -l1 "


#    Analogue Card EEPROM is at 0x100 => 0x2FE

#    Ge Card Identification

       ecc_register ManID             xDig "-s$slot -o0x100 -w16 -pro -fx"
       ecc_register SerialNum         xDig "-s$slot -o0x108 -w16 -pro -fx"
       ecc_register ModLevel          xDig "-s$slot -o0x10a -w16 -pro -fx"

#    GIR registers      

       ecc_register   GIR.EvNum.Count         xDig  "-s$slot  -o0x300 -w16 -prw -fx -b0 -l0"
        if {[first [split $registerbase #]] == "$registerbase"} then {
           ecc_register   GIR.EvNum.Addr          xAdr  "-s$slot  -c0 -o0x302 -w16 -b0 -l0 -i$registerbase.EVRI.EvNum"
        } else {
           ecc_register   GIR.EvNum.Addr          xDig  "-s$slot  -c0 -o0x302 -w16 -prw -fx -b0 -l0"
        }
       ecc_register   GIR.EvNum               xDig  "-s$slot  -o0x300 -w32 -pro -fx -b0 -l0"

       ecc_register   GIR.FIFO.Test           xFIT  "-s$slot  -o0x304 -w32 -prw -fx"
       ecc_register   GIR.ValAck.TimeOut      xDAC  "-s$slot -c0 -a0 -z0 -o0x30e -w16 -prw -qn -us -d0 -r0:0s,0xffff:2048000ns -i25000ns"


       ecc_register   GIR.DCR                 xDig  "-s$slot  -o0x308 -w16 -prw -fx -b0 -l0 -i0"

       ecc_register   GIR.DCR.DataXfer1.Enable    xDig    "-s$slot  -o0x308 -w16 -prw -fx -b0 -l1"
       ecc_register   GIR.DCR.DataXfer2.Enable    xDig    "-s$slot  -o0x308 -w16 -prw -fx -b1 -l1"
       ecc_register   GIR.DCR.DSP_Enable          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b2 -l1"
       ecc_register   GIR.DCR.DMA_TEST          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b3 -l1"
       ecc_register   GIR.DCR.Process          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b4 -l4"
       ecc_register   GIR.DCR.Spectre          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b4 -l1"
       ecc_register   GIR.DCR.Scaler          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b5 -l1"
       ecc_register   GIR.DCR.bit6          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b6 -l1"
       ecc_register   GIR.DCR.bit7          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b7 -l1"

#	Ch. Theisen 1.4.2003
#       ecc_register   GIR.RCR                 xDig  "-s$slot  -o0x30a -w16 -prw -fx -b0 -l0"
       ecc_register   GIR.RCR                 xDig  "-s$slot  -o0x30a -w16 -prw -fx -b0 -l0 -i 0x0005"

       ecc_register   GIR.RCR.ValAck.TimeOutReset xDig    "-s$slot  -o0x30a -w16 -prw -fx -b0 -l1 -i1"
       ecc_register   GIR.RCR.ReadOut.Disable     xDig    "-s$slot  -o0x30a -w16 -prw -fx -b1 -l1"
       ecc_register   GIR.RCR.EvNumData.Disable   xDig    "-s$slot  -o0x30a -w16 -prw -fx -b2 -l1"
       ecc_register   GIR.RCR.QStat xDig    "-s$slot  -o0x30a -w16 -prw -fx -b3 -l1"
       ecc_register   GIR.RCR.Pipeline.Enable     xDig    "-s$slot  -o0x30a -w16 -prw -fx -b4 -l1"
       ecc_register   GIR.RCR.CommonDeadtime.Enable   xDig    "-s$slot  -o0x30a -w16 -prw -fx -b5 -l1"
       ecc_register   GIR.RCR.ExtReadout.Enable     xDig    "-s$slot  -o0x30a -w16 -prw -fx -b6 -l1"
       ecc_register   GIR.RCR.TestParil.Enable   xDig    "-s$slot  -o0x30a -w16 -prw -fx -b7 -l1"

       ecc_register   GIR.ROTSR               xDig  "-s$slot  -o0x30c -w16 -pro -fx -b0 -l0"

       ecc_register   GIR.ROTSR.Temp.Status.GIR       xDig    "-s$slot  -o0x30c -w16 -pro -fx -b0 -l2"
       ecc_register   GIR.ROTSR.Temp.Status1          xDig    "-s$slot  -o0x30c -w16 -pro -fx -b2 -l2"
       ecc_register   GIR.ROTSR.Temp.Status2          xDig    "-s$slot  -o0x30c -w16 -pro -fx -b4 -l2"
       ecc_register   GIR.ROTSR.ValAck.TimeOut.Status xDig    "-s$slot  -o0x30c -w16 -pro -fx -b6 -l1"
       ecc_register   GIR.ROTSR.FIFO.Status           xDig    "-s$slot  -o0x30c -w16 -pro -fx -b7 -l2"

#    DSP registers

	ecc_register   GIR.DSP.ExtMem     bVXI    "-s$slot  -a0x200000 -o0x0 -w32 -pro -fx -l64"
	ecc_register   GIR.DSP.IntMem     bVXI    "-s$slot  -a0x400000 -o0x0 -w32 -pro -fx -l64"
	ecc_register   GIR.DSP.SpectrumData     bVXI    "-s$slot  -a0x200000 -o0x0 -w32 -pro -fx -l64"
	ecc_register   GIR.DSP.Program    xGIR    "-s$slot  -a0x400010 -l8192 -v4 -m0 -i/MIDAS/vxi/tcl/gir/DspLdr/4/ECC.ldr"

	ecc_register   GIR.DSP.Control      xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b0 -l0"

	ecc_register   GIR.DSP.StartDSP     xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b0 -l1"
	ecc_register   GIR.DSP.FIlterMode   xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b1 -l1"
	ecc_register   GIR.DSP.StopDSP      xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b2 -l1"
	ecc_register   GIR.DSP.DSPtotcount  xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b3 -l1"
	ecc_register   GIR.DSP.ResetDSP     xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b4 -l1"
	ecc_register   GIR.DSP.Muxalim      xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b5 -l1"
	ecc_register   GIR.DSP.PZ           xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b6 -l1"
	ecc_register   GIR.DSP.ResetMemExt  xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b7 -l1"
	ecc_register   GIR.DSP.Process      xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b8 -l4"
	ecc_register   GIR.DSP.Spectre      xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b8 -l1"
	ecc_register   GIR.DSP.Scaler       xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b9 -l1"

	ecc_register   GIR.DSP.Bit10        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b10 -l1"
	ecc_register   GIR.DSP.Bit11        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b11 -l1"
	ecc_register   GIR.DSP.Bit12        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b12 -l1"
	ecc_register   GIR.DSP.Bit13        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b13 -l1"
	ecc_register   GIR.DSP.Bit14        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b14 -l1"
	ecc_register   GIR.DSP.Bit15        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b15 -l1"
	ecc_register   GIR.DSP.Bit16        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b16 -l1"
	ecc_register   GIR.DSP.Bit17        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b17 -l1"

	ecc_register   GIR.DSP.Syscon       xDig    "-s$slot  -a0x400000 -o0x0 -w32 -prw -fd -b0 -l0 "
	ecc_register   GIR.DSP.Wait         xDig    "-s$slot  -a0x400000 -o0x8 -w32 -prw -fd -b12 -l3 "

	ecc_register   GIR.DSP.Reg0         xDig    "-s$slot  -a0x400000 -o0x98000 -w32 -prw -fd -b0 -l0 "
	ecc_register   GIR.DSP.Item         xDig    "-s$slot  -a0x400000 -o0x98004 -w32 -prw -fx -b0 -l0"
	ecc_register   GIR.DSP.Reg2         xDig    "-s$slot  -a0x400000 -o0x98008 -w32 -prw -fd -b0 -l0 "
	ecc_register   GIR.DSP.Reg3         xDig    "-s$slot  -a0x400000 -o0x9800C -w32 -prw -fd -b0 -l0 "
	ecc_register   GIR.DSP.Reg4         xDig    "-s$slot  -a0x400000 -o0x98010 -w32 -prw -fd -b0 -l0 "
	ecc_register   GIR.DSP.Reg5         xDig    "-s$slot  -a0x400000 -o0x98014 -w32 -prw -fd -b0 -l0 "
	ecc_register   GIR.DSP.Reg6         xDig    "-s$slot  -a0x400000 -o0x98018 -w32 -prw -fd -b0 -l0 "
	ecc_register   GIR.DSP.DeltaPZ      xDig    "-s$slot  -a0x400000 -o0x9801C -w32 -prw -fd -b0 -l0 "
	ecc_register   GIR.DSP.inmux        xDig    "-s$slot  -a0x400000 -o0x98080 -w32 -prw -fd -b0 -l0 "
	ecc_register   GIR.DSP.PosBit       xDig    "-s$slot  -a0x400000 -o0x98084 -w32 -prw -fd -b0 -l6 "
	ecc_register   GIR.DSP.NbBit        xDig    "-s$slot  -a0x400000 -o0x98084 -w32 -prw -fd -b6 -l6 "
}

proc ECCDetectorRegisters {slot socket segment} {
    global registerbase nsegments

        set c [expr (($socket - 1) * $nsegments) + $segment]

#    DAC Sliding Scale setup

       ecc_register   6MeV.SSRamp          xDig    "-s$slot -c$c -z12  -a0x110 -o0x0 -w16 -prw -fx -b0 -l0"
       ecc_register   6MeV.SSOffset        xDig    "-s$slot -c$c -z12  -a0x110 -o0x2 -w16 -prw -fx -b0 -l0"
       ecc_register   20MeV.SSRamp         xDig    "-s$slot -c$c -z12  -a0x110 -o0x4 -w16 -prw -fx -b0 -l0"
       ecc_register   20MeV.SSOffset       xDig    "-s$slot -c$c -z12  -a0x110 -o0x6 -w16 -prw -fx -b0 -l0"
       ecc_register   TAC.SSRamp           xDig    "-s$slot -c$c -z12  -a0x110 -o0x8 -w16 -prw -fx -b0 -l0"
       ecc_register   TAC.SSOffset         xDig    "-s$slot -c$c -z12  -a0x110 -o0xa -w16 -prw -fx -b0 -l0"

#    DAC Adjustment

       ecc_register   PDSGate.Width     xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x00 -w16 -pwo -fd -l8 -i240"
       ecc_register   PoleZero.Thresh   xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x02 -w16 -pwo -fd -l8 -i90"
       ecc_register   6MeV.Offset       xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x04 -w16 -pwo -fd -l8 -i128"
       ecc_register   20MeV.Offset      xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x06 -w16 -pwo -fd -l8 -i128"
       ecc_register   FTSample.Thresh   xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x08 -w16 -pwo -fd -l8 -i105"
       ecc_register   CFD.Delay         xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x0a -w16 -pwo -fd -l8 -i20"
       ecc_register   PileUp.Thresh     xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x0c -w16 -pwo -fd -l8 -i66"
       ecc_register   CFD.Thresh        xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x0e -w16 -pwo -fd -l8 -i50"

#    Potentiometer Adjustment

       ecc_register   PotAdjust.6MeV_Neg  xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x10 -w16 -prw -fd -l8"
       ecc_register   PotAdjust.6MeV_Pos  xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x12 -w16 -prw -fd -l8"

#    Channel Control Register

       ecc_register   CCR                     xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x20 -w16 -prw -fx -b0 -l0"

       ecc_register   Enable                  xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x20 -w16 -prw -fx -b0 -l1 -i0x0"
       ecc_register   TestGen.Enable          xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x20 -w16 -prw -fx -b1 -l1"
       ecc_register   PreAmp_Input_Polarity   xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x20 -w16 -prw -fx -b2 -l1"
       ecc_register   DPPC.Enable             xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x20 -w16 -prw -fx -b3 -l1"
       ecc_register   Shaping_Amp_Range       xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x20 -w16 -prw -fx -b4 -l1"
       ecc_register   DPPC_Input_Mode         xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x20 -w16 -prw -fx -b5 -l1"
       ecc_register   TAC_Range               xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x20 -w16 -prw -fx -b6 -l1 -i0x1"

       ecc_register   DAC_Output_Mode         xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x30 -w16 -pwo -fx -l8 -i0xFF"

#    PARIL Setup
#######################################

       ecc_register   20MeV.Addr  xAdr "-s$slot -c$c -a0x1000 -z0x1000 -o0x200 -w32 -i$registerbase.20MeV"
       ecc_register   6MeV.Addr   xAdr "-s$slot -c$c -a0x1000 -z0x1000 -o0x204 -w32 -i$registerbase.6MeV"
       ecc_register   TAC.Addr    xAdr "-s$slot -c$c -a0x1000 -z0x1000 -o0x208 -w32 -i$registerbase.TAC"

        set VMEaddr [expr [expr $c * 0x1000] + 0x1000 + 0x20c]
       ecc_register   PARIL.DPPC_DataMem     bVXI "-s$slot -a$VMEaddr -w32 -pro -fx -l12"

       ecc_register   PARIL.DPPC_Data_Num    xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x240 -w32 -prw -fx -b0 -l0 -i0x4"
       ecc_register   PARIL.DPPC_Mem_Offset  xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x244 -w32 -prw -fx -b0 -l0 -i0x7000"
       ecc_register   PARIL.TFG_Count     xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x248 -prw -w16 -fx -b0 -l0"
       ecc_register   PARIL.RCR           xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x250 -w16 -prw -fx -b0 -l0 "
       ecc_register   PARIL.RCS           xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x254 -w16 -prw -fx -b0 -l0 -i0x0"
       ecc_register   PARIL.Insp1         xMux "-s$slot -c$c -a0x1000 -z0x1000 -o0x258 -w32 -prw -b0 -l16 -dECC -mp1"
       ecc_register   PARIL.Insp2         xMux "-s$slot -c$c -a0x1000 -z0x1000 -o0x25c -w32 -prw -b0 -l16 -dECC -mp2"
       ecc_register   PARIL.SSRS_Cmd      xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x260 -w32 -prw -fx"
       ecc_register   PARIL.SSRC_Cmd      xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x264 -w32 -prw -fx"
       ecc_register   PARIL.SEOC_Cmd      xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x268 -w32 -prw -fx"
       ecc_register   PARIL.SE_Cmd        xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x26C -w32 -prw -fx"
       ecc_register   PARIL.DPPC.Program  xDppc "-s$slot -c$c -a0x1000 -z0x1000 -o0x280 -l8192 -m0 -i/MIDAS/dppc/ECC.dxe"
       ecc_register   PARIL.DPPC_Data     xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x280 -w16 -prw -fx"
       ecc_register   PARIL.DPPC_Addr     xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x284 -w16 -pwo -fx"
       ecc_register   PARIL.Scaler        xAdr "-s$slot -c$c -a0x1000 -z0x1000 -o0x288 -w16 -pro -fd -b0 -l0"
       ecc_register   PARIL.RealTFG_Count xAdr "-s$slot -c$c -a0x1000 -z0x1000 -o0x28C -w16 -pro -fx -b0 -l0"


#    PARIL Corrolated Control Register 0x250
#######################################
       ecc_register   6MeV.ROEnable      xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x250 -w16 -prw -fx -b0 -l1 -i0x1"
       ecc_register   20MeV.ROEnable     xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x250 -w16 -prw -fx -b1 -l1 -i0x1"
       ecc_register   TAC.ROEnable       xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x250 -w16 -prw -fx -b2 -l1 -i0x1"
       ecc_register   DPPC.ROEnable      xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x250 -w16 -prw -fx -b3 -l13 -i0x0"

#    PARIL singles Control Register 0x254
#######################################
       ecc_register   PARIL.RCS.SingleEnable  xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x254 -w16 -prw -fx -b0 -l1 -i0x1"
       ecc_register   PARIL.RCS.TAC_TFG       xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x254 -w16 -prw -fx -b1 -l1 -i0x0"
       ecc_register   PARIL.RCS.TFGEnable     xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x254 -w16 -prw -fx -b2 -l1 -i0x0"
       ecc_register   PARIL.RCS.LinkAckFP_AP  xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x254 -w16 -prw -fx -b3 -l1 -i0x0"
       ecc_register   PARIL.RCS.LTreset       xDig "-s$slot -c$c -a0x1000 -z0x1000 -o0x254 -w16 -prw -fx -b4 -l1 -i0x0"
}


proc ECC_DAQ-setup   {args}   {
   global ECC_registersavepatterns EGreport
   
   set module [first $args]

#    only perform GIR functions for event numbered modules (stops us doing it twice per card)
   set i [string range $module 3 end]
   set j [expr $i + 1]
   if {[expr ($i/2)*2] != $i} then {return}

#    save volatile registers which will be reset by a GIR software reset
    set EGreport_SAVE $EGreport
    set EGreport -1
    foreach r [set ECC_registersavepatterns] {
        set $r [read-vxi-register $module.$r]
    }
    
#    load DPPC program  (default)
    write-vxi-register $module.ResetGIR 1
    write-vxi-register $module.ResetGIR 0

    insert-log "GIR reset for $module"
    
    modify-vxi-registers ECC$i.\[A-D\].PARIL.DPPC.Program "-m 2"

    write-vxi-registers  ECC$i.\[A-D\].PARIL.DPPC.Program ""
    foreach k [list A B C D] {insert-log "Program [read-vxi-register  ECC$i.$k.PARIL.DPPC.Program] loaded into DPPC $k in ECC$i"}

    modify-vxi-registers ECC$i.\[A-D\].PARIL.DPPC.Program "-m 0"

    modify-vxi-registers ECC$j.\[A-D\].PARIL.DPPC.Program "-m 2"

    write-vxi-registers  ECC$j.\[A-D\].PARIL.DPPC.Program ""
    foreach k [list A B C D] {insert-log "Program [read-vxi-register  ECC$j.$k.PARIL.DPPC.Program] loaded into DPPC $k in ECC$j"}

    modify-vxi-registers ECC$j.\[A-D\].PARIL.DPPC.Program "-m 0"

    after 10

    write-vxi-registers ECC\[$i-$j\].\[A-D\].PARIL.DPPC_Addr 0x6101
    write-vxi-registers ECC\[$i-$j\].\[A-D\].PARIL.DPPC_Data 0

    write-vxi-registers ECC\[$i-$j\].\[A-D\].PARIL.DPPC_Addr 0x6100
    write-vxi-registers ECC\[$i-$j\].\[A-D\].PARIL.DPPC_Data 8

    write-vxi-registers ECC\[$i-$j\].\[A-D\].PARIL.DPPC_Addr 0x6101
    write-vxi-registers ECC\[$i-$j\].\[A-D\].PARIL.DPPC_Data 0x40

    write-vxi-registers ECC\[$i-$j\].\[A-D\].PARIL.DPPC_Addr 0x6100
    write-vxi-registers ECC\[$i-$j\].\[A-D\].PARIL.DPPC_Data 4

    write-vxi-registers ECC\[$i-$j\].\[A-D\].PARIL.DPPC_Addr 0x6100
    write-vxi-registers ECC\[$i-$j\].\[A-D\].PARIL.DPPC_Data 3

#    write-vxi-registers ECC\[$i-$j\].\[A-D\].DPPC.Enable 1

#    load DSP program  (default)
    write-vxi-register $module.DSP.Reset 1
    write-vxi-register $module.DSP.Reset 0

    modify-vxi-register $module.GIR.DSP.Program "-m 2"
    write-vxi-register  $module.GIR.DSP.Program ""
    modify-vxi-register $module.GIR.DSP.Program "-m 0"

    insert-log "Program [read-vxi-register  $module.GIR.DSP.Program] loaded into GIR DSP in $module"

    initialise-vxi-registers ECC\[$i-$j\].*

#    restore volatile registers which will be reset by a GIR software reset
    foreach r [set ECC_registersavepatterns] {
        write-vxi-register $module.$r [set $r]
    }
    set EGreport $EGreport_SAVE

    insert-log "Setup registers for ECC$i and ECC$j - A parameter restore is needed"
}

proc ECC_DAQ-reset   {args}   {
   set module [first $args]
}

proc ECC_DAQ-halt   {args}   {
   set module [first $args]

# stop DSP GIR
   write-vxi-register $module.GIR.DSP.StartDSP 0

}

proc ECC_DAQ-go   {args}   {

   set module [first $args]

#    only perform GIR functions for event numbered modules (stops us doing it twice per card)
   set i [string range $module 3 end]
   if {[expr ($i/2)*2] == $i} then {

#  flush FIFOs
    write-vxi-register $module.FIFO.Reset 0
    write-vxi-register $module.FIFO.Reset 1
    write-vxi-register $module.FIFO.Reset 0

#  reset and enable GIR FIFOs
   write-vxi-register $module.GIR.FIFO.Test 0
   read-vxi-register $module.GIR.FIFO.Test

   write-vxi-register $module.GIR.RCR.EvNumData.Disable 1
  }

#    Start is now in go-vxi-crate
#  reset Local trigger
   write-vxi-registers $module.\[A-D\].PARIL.RCS.LTreset 1
   write-vxi-registers $module.\[A-D\].PARIL.RCS.LTreset 0


#    only perform GIR functions for event numbered modules (stops us doing it twice per card)
   set i [string range $module 3 end]
   if {[expr ($i/2)*2] == $i} then {

#  zero GIR event numbers
   write-vxi-register $module.GIR.EvNum.Count 0

#    Init DAQ with GIR DSP

   write-vxi-register $module.GIR.DCR.DSP_Enable 1
   write-vxi-register $module.GIR.DCR.DataXfer1.Enable 1
   set data3 [read-vxi-register $module.A.6MeV.Addr]
   write-vxi-register $module.GIR.DSP.Item $data3

  set spectraflag($module) [read-vxi-register $module.GIR.DCR.Process]
  write-vxi-register $module.GIR.DSP.Process $spectraflag($module)

#    start the GIR DSP
  write-vxi-register $module.GIR.DSP.StartDSP 1

 }
}

set ECC_registersavepatterns {
   A.CCR B.CCR C.CCR D.CCR
   A.CFD.Thresh   B.CFD.Thresh  C.CFD.Thresh  D.CFD.Thresh
   A.CFD.Delay    B.CFD.Delay   C.CFD.Delay   D.CFD.Delay
   A.FTSample.Thresh B.FTSample.Thresh C.FTSample.Thresh D.FTSample.Thresh
   A.PoleZero.Thresh B.PoleZero.Thresh C.PoleZero.Thresh D.PoleZero.Thresh
   A.PileUp.Thresh B.PileUp.Thresh C.PileUp.Thresh D.PileUp.Thresh
   A.PDSGate.Width B.PDSGate.Width C.PDSGate.Width D.PDSGate.Width
   A.20MeV.Offset B.20MeV.Offset C.20MeV.Offset D.20MeV.Offset
   A.20MeV.ROEnable B.20MeV.ROEnable C.20MeV.ROEnable D.20MeV.ROEnable
   A.6MeV.Offset B.6MeV.Offset C.6MeV.Offset D.6MeV.Offset
   A.6MeV.ROEnable B.6MeV.ROEnable C.6MeV.ROEnable D.6MeV.ROEnable
   A.TAC.ROEnable B.TAC.ROEnable C.TAC.ROEnable D.TAC.ROEnable
   A.PotAdjust.6MeV_Neg B.PotAdjust.6MeV_Neg C.PotAdjust.6MeV_Neg D.PotAdjust.6MeV_Neg
   A.PotAdjust.6MeV_Pos B.PotAdjust.6MeV_Pos C.PotAdjust.6MeV_Pos D.PotAdjust.6MeV_Pos
   Valid_Thresh Addback_Thresh
   GIR.RCR GIR.DCR GIR.ValAck.TimeOut PileupReject CFD.Width MCR_analog
   A.PARIL.RCS B.PARIL.RCS C.PARIL.RCS D.PARIL.RCS
}
