#    part of the Diagnostic task for testing GIR DSP functions
#    this is girstatus.tcl

#    the following table information for the GIR is taken from the file  gir.tcl

global moduleindex card


set table(GIRROCREVNUMDATADISABLE) {girevnumdatadisable logic-widget->param param->logic-widget "GIR.RCR.EvNumData.Disable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRREADOUTDISABLE) {girreadoutsdisable logic-widget->param param->logic-widget "GIR.RCR.ReadOut.Disable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRVALACKTIMEOUTRESET) {girrocrvalacktimeoutreset logic-widget->param param->logic-widget "GIR.RCR.ValAck.TimeOutReset"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRDCRFILTER) {girdcrfilter int-widget->param param->int-widget "GIR.DCR.DataXfer2.Enable"
                     int-reg->param param->int-reg nil :choice   nil nil nil 1 "DSP Mode"}

set table(GIROFFSETADC)    {giroffsetadc    slider-widget->param param->int-widget "GIR.DSP.Reg6"
                     unit-reg->param param->unit-reg mv :slider 8000 10000 1 1 "ADC Offset"}



#set table(GIRDCRDSPENABLE) {girdcrdspenable logic-widget->param param->logic-widget "GIR.DCR.DSP_Enable"
#                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
#set table(GIRDCRSARDSPENABLE) {girdcrsardspenable logic-widget->param param->logic-widget "GIR.DCR.DataXfer1.Enable"
#                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
#set table(GIRDCRDSPFIFOENABLE) {girdcrdspfifoenable logic-widget->param param->logic-widget "GIR.DCR.DataXfer2.Enable"
#                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRDCRSPECTRE) {girdcrspectre logic-widget->param param->logic-widget "GIR.DCR.Spectre"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRDCRSCALER) {girdcrscaler logic-widget->param param->logic-widget "GIR.DCR.Scaler"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRROTSRFIFOSTATUS)    {girrotsrfifostatus    int-widget->param param->FIFO-widget "GIR.ROTSR.FIFO.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRTEMPSTATUSGIR)    {girrotsrtempstatusgir    int-widget->param param->TEMP-widget "GIR.ROTSR.Temp.Status.GIR"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRTEMPSTATUS1)    {girrotsrtempstatus1    int-widget->param param->ATEMP-widget "GIR.ROTSR.Temp.Status1"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRTEMPSTATUS2)    {girrotsrtempstatus2    int-widget->param param->ATEMP-widget "GIR.ROTSR.Temp.Status2"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRREADTEMPHIGH)    {girtcrreadtemphigh    int-widget->param param->degree-widget "GIR.TCR.ReadTempHigh"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRREADTEMPLOW)    {girtcrreadtemplow    int_widget->param param->degree-widget "GIR.TCR.ReadTempLow"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRWRITETEMPHIGH)    {girtcrwritetemphigh    int-widget->param param->int-widget "GIR.TCR.WriteTempHigh"
                     degree-reg->param param->degree-reg 2 :text 4 nil nil 1 "Temp high"}

set table(GIRTCRWRITETEMPLOW)    {girtcrwritetemplow   int-widget->param param->int-widget "GIR.TCR.WriteTempLow"
                     degree-reg->param param->degree-reg 2 :text 4 nil nil 1 "Temp low"}

set table(GIRTCRREADTEMP)    {girtcrreadtemp    int-widget->param param->degree-widget "GIR.TCR.ReadTemp"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRREADALARMLOW) {girtcrreadalarmlow  logic-widget->param param->logic-widget "GIR.TCR.ReadConfig.Low"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRREADALARMHIGH) {girtcrreadalarmhigh  logic-widget->param param->logic-widget "GIR.TCR.ReadConfig.High"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRROTSRVALACKTIMEOUTSTATUS) {girrotsrvalacktimeoutstatus  logic-widget->param param->logic-widget "GIR.ROTSR.ValAck.TimeOut.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRVALACKTIMEOUT)    {girvalacktimeout    slider-widget->param param->int-widget "GIR.ValAck.TimeOut"
                     unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}


#    conversion procedures taken from common.vxi.tcl


#
#    procedures used to convert a widget value into a parameter  ##############################
#


proc int-widget->param {p v s} {global $p; set $p $v}

proc hex-widget->param {p v s} {global $p; set $p $v}

proc str-widget->param {p v s} {global $p; set $p $v}

proc logic-widget->param {p v s} {global $p; set $p [expr $v & 1]}

proc widget->param {p v s} {global $p; set $p $v}

proc slider-widget->param {p v s} {
	global $p 
	set oldv [set $p]

	if {$v==$oldv+1} then {set v [expr $oldv+$s]}
	if {$v==$oldv-1} then {set v [expr $oldv-$s]}
	set $p $v
}

#
#    procedures used to convert a register value into a parameter    #############################
#

proc reg->param {p v} {global $p; set $p $v}

proc int-reg->param {p v} {global $p; set $p  [scan-int $v]}


proc str-reg->param {p v} {global $p; set $p $v}

proc int-reg->choice-param {p v} {}

proc unit-reg->param {p v} {global $p; set $p [scan-int $v]}
proc degree-reg->param {p v} {global $p; set $p [scan-int $v]}

proc not-reg->param {p v} {global $p; set $p [expr [scan-int $v]^1]}


#
#    procedures used to convert a parameter into a widget value   ############################
#

proc param->TEMP-widget {p v u} {
#    insert-debug "param->TEMP-widget $p $v $u"
    switch $v {
       1  {set s higher}
       2  {set s lower}
       0  {set s ok}
       default {set s ??}
    }
    return "$p :value $s"
}

proc param->ATEMP-widget {p v u} {
#    insert-debug "param->TEMP-widget $p $v $u"
     global card

switch $card {
ClusterBGO {set s none}
default {
    switch $v {
       2  {set s higher}
       1  {set s lower}
       3  {set s ok}
       default {set s ??}
    }
}
}
    return "$p :value $s"
}


proc param->FIFO-widget {p v u} {
    switch $v {
       1  {set s Full}
       2  {set s Empty}
       3  {set s Data}
      default {set s ??}
    }

    return "$p :value $s"
}


proc param->degree-widget {p v u} {
return "$p :value [expr $v/2]"}

proc param->int-widget {p v u} {return "$p :value $v" }

proc real-param->int-widget {p v u} {return "$p :value [truncate [expr $v+0.5]]"}

proc param->logic-widget {p v u} {
   if {$v == 0} then {set vl 0} else {set vl 1}
   return "$p :value $vl" 
}

proc param->str-widget {p v u} {return "$p :value $v" }

proc param->hex-str-widget {p v u} {format "%s :value 0x%x" $p $v }

proc param->hex-widget {p v u} {format "%s :value 0x%x" $p $v }


proc param->choice-widget {p v u} {}

proc param->reg {p v u} {return "$v"}

proc param->int-reg {p v u} {return "$v"}

proc param->degree-reg {p v u} {return "[expr $v*$u]"}

proc param->unit-reg {p v u} {return "$v$u"}
proc param->unit-reg {p v u} {global $p; return "[set $p]$u"}

proc param->not-reg {p v u} {return "[expr $v^1]"}

proc param->spare-reg {p v u} {puts stderr "param->spare-reg $p $v $u"; return "$v"}



proc Redisplay {} {
  global CurrentVXIModule table moduleindex card
        :modify MODULE :value $moduleindex
        :modify CARD :value $card


  foreach widget [array names table] {
     set entry $table($widget)
     set reg [lindex $entry 3]

     if {$reg == "nil"} then {continue}

     set data [read-vxi-register $CurrentVXIModule.$reg]

     set param [lindex $entry 0]
     set p2w [lindex $entry 2]
     set r2p [lindex $entry 4]
     set unit [lindex $entry 6]
     $r2p $param $data
     global $param
     set data [set $param]
     eval :modify [$p2w $widget $data $unit]
  }


}


proc click-GIRwindow  {w v} {
    switch -glob $w {
      GIRVALACKTIMEOUT -
      GIROFFSETADC -
      GIRDCR*     -
      GIRROCR*    -
      GIRTCR*     -
      GIRROTSR*    {click-on $w $v}
   }
}


proc click-on {w v} {
   global CurrentVXIModule table

   set entry "$table($w)"
   set param [lindex $entry 0]
   set w2p [lindex $entry 1]
   set p2w [lindex $entry 2]
   set reg [lindex $entry 3]
   set p2r [lindex $entry 5]
   set unit [lindex $entry 6]
   set step [lindex $entry 10]

   $w2p $param $v $step

   if {$reg!="nil"} then {
       write-vxi-register $CurrentVXIModule.$reg [$p2r $param $v $unit]
   }

   Redisplay
}



set col1 15c
set col2 30c

  :frame [self frame-name].gir :label "GIR Status" :show-footer T :resize F :transient T 

  :panel PANEL1 :layout T :padx 5 :pady 5
    :layout H; :row-gap 5; :col-gap 25
      :text     MODULE    :label "Current Module:"  :deaf T :valuex 20c :w 4 :bold T :value $moduleindex
      :text     CARD    :label "Current Card:"  :deaf T :valuex 15c :w 12 :bold T :value $card
     :next-row T
      :message M1 :label "DSP CONTROL REGISTER" :bold T
      :next-row T
      :checkbox GIRDCRSPECTRE  :label "Enable Spectra" :valuex $col1 
      :button GIRSSCALIBRATE   :label "GOCCE  SS CALIBRATION"  :command click-sscalibrate :w 25 :bold T 
# Not used for the moment      :button GIRSSABORT   :label "abortSS"  :command click-ssabort
      :next-row T
      :checkbox GIRDCRSCALER  :label "Enable Scaler" :valuex $col1
      :choice GIRDCRFILTER :label "DSP DAQ Mode" :strings [list SPY FILTER] :value 0   :valuex 14c :bold T
      :next-row T
      :slider  GIROFFSETADC          :label "Offset ADC"  :min 8000 :max 10000
      :next-row T

      :vskip 10

  :panel PANEL2 :layout T :padx 5 :pady 5
    :layout V; :row-gap 5; :col-gap 5
      :message M2 :label "READOUT CONTROL REGISTER" :bold T
      :checkbox GIRROCRVALACKTIMEOUTRESET :label "Enable Valack Timeout Reset" :valuex $col2
      :checkbox GIRROCRREADOUTDISABLE  :label "Disable GIR Readout:" :valuex $col2
      :checkbox GIRROCREVNUMDATADISABLE   :label "Event Number Readout Disable:" :valuex $col2

      :vskip 10



  :panel PANEL3 :layout T :padx 5 :pady 5
    :layout H; :row-gap 5; :col-gap 5
      :message M3 :label "READOUT STATUS REGISTER"  :bold T
      :next-row T
      :hskip 10
      :text    GIRROTSRFIFOSTATUS  :label "Fifo:" :bold T :valuex 6c :w 6
      :next-row T
      :hskip 10
      :message M4 :label "Valack Timeout:" :bold T 
      :next-row T
      :checkbox GIRROTSRVALACKTIMEOUTSTATUS     :label "Asserted:" :deaf T
      :slider  GIRVALACKTIMEOUT          :label "(ns):"  :min 0 :max 2000000 :resolution 62

      :next-row T
      :vskip 10
      :message M5 :label "TEMPERATURE REGISTER"  :bold T
      :next-row T
      :hskip 10
      :message M6 :label "Analog"  :bold T
      :text    GIRROTSRTEMPSTATUS1    :label "Sensor 1:"   :valuex 8c :w 6
      :text    GIRROTSRTEMPSTATUS2    :label "Sensor 2:"   :valuex 8c :w 6

      :next-row T
      :hskip 10
      :message M7 :label "GIR"  :bold T
      :next-row T
      :message M8 :label "Thresh : " 
      :message M9 :label "Read : " 
      :message M10 :label "Write : " 
      :message M11 :label "Alarm : " 
      :message M12 :label "Clear : " 

      :col-gap 15
      :next-row T
       :text    GIRTCRREADTEMPHIGH     :label "High (C): " :read-only T :w 6
      :text    GIRTCRWRITETEMPHIGH     :label "" :w 6
      :checkbox GIRTCRREADALARMHIGH     :label "" :deaf T :colours [list green red]
      :button GIRTCRCLRALARM  :label "Clear"  :command click-girtcrclralarm
      :next-row T
      :text    GIRTCRREADTEMPLOW     :label "Low (C):  " :read-only T :w 6
      :text    GIRTCRWRITETEMPLOW     :label "" :w 6
      :checkbox GIRTCRREADALARMLOW     :label "" :deaf T :colours [list green blue]
      :next-row T
      :text    GIRTCRREADTEMP     :label "Temp (C):" :read-only T :w 6
      :text    GIRROTSRTEMPSTATUSGIR :label "" :read-only T :w 6
      :col-gap 30
      :button GIRREDISPLAY  :label Redisplay :command Redisplay
    :show T


   Redisplay



proc click-girtcrclralarm {} {
global CurrentVXIModule
write-vxi-register $CurrentVXIModule.GIR.TCR.ClearAlarm 0
after 1000
Redisplay
}



proc click-sscalibrate {} {
global CurrentVXIModule

# This step is needed to prepare the DSP before any calibration is made.
# The DSP  program step must be in the main menu waiting for an order.
# this means that we must stop the DSP before the sliding scale calibration.
#SAVE THE DSP Control register @0x2ffd0, or 0x dsp+0xbff40 in VME space

 set DSPCONTROLSTATUS [read-vxi-register $CurrentVXIModule.GIR.DSP.Control]

 write-vxi-register $CurrentVXIModule.GIR.DSP.Control 0
after 10
# We must reset all the current variables and counts inside the DSP program first.
# wait 100 ms for the RESET procedure to finish before reinitialise the DSP.

 write-vxi-register $CurrentVXIModule.GIR.DSP.ResetDSP 1
after 15

# We need to initialise the item0 which is needed to store the ADC calibration parameters.

set data3 [read-vxi-register $CurrentVXIModule.XtalA.Seg0.Energy.Addr]
write-vxi-register $CurrentVXIModule.GIR.DSP.Item $data3

# Read the necessary status of all the registers that need to be modified for the 
# sliding scale correction before modifying them
# so that we can go back to the old status of the card.
# In this way there will be no residues from the SS calibration effect on the card.


 set CRCSTATUS [read-vxi-register $CurrentVXIModule.CRC] 
 set rcrA [read-vxi-register $CurrentVXIModule.XtalA.RCR] 
 set rcrB [read-vxi-register $CurrentVXIModule.XtalB.RCR] 
 set rcrC [read-vxi-register $CurrentVXIModule.XtalC.RCR] 
 set rcrD [read-vxi-register $CurrentVXIModule.XtalD.RCR] 
 set DCRSTATUS [read-vxi-register $CurrentVXIModule.GIR.DCR]
 

# We need to enable all the energy parameters for the sliding scale calculations.

 write-vxi-register $CurrentVXIModule.XtalA.RCR 0x180f 
 write-vxi-register $CurrentVXIModule.XtalB.RCR 0x180f 
 write-vxi-register $CurrentVXIModule.XtalC.RCR 0x180f
 write-vxi-register $CurrentVXIModule.XtalD.RCR 0x180f 

# This step is very essential to get rid of the current sliding scale value at the dac output.

 write-vxi-register $CurrentVXIModule.CRC.SSEnable 0	
 write-vxi-register $CurrentVXIModule.CRC.SSMode 0	
 write-vxi-register $CurrentVXIModule.CRC.SSMode 1	
 write-vxi-register $CurrentVXIModule.CRC.SSMode 0	

# We must reset the Common Register Control and the DCR

write-vxi-register $CurrentVXIModule.CRC 0x0 
write-vxi-register $CurrentVXIModule.GIR.DCR 0x0 


# Enable  the GIR DCR Sliding Scale calibration.


write-vxi-register $CurrentVXIModule.GIR.DCR.ADCSSE 1

# Enable  the DSP  Sliding Scale calibration Register.

write-vxi-register $CurrentVXIModule.GIR.DSP.SSCalibrateEn 1


# Enable  the GOCCE Sliding Scale calibration.

write-vxi-register $CurrentVXIModule.CRC.DspSSCalibrateEn 1


#Configure the DSP acquisition as normal DAQ run without filter mode.

write-vxi-register $CurrentVXIModule.GIR.DCR.DSP_Enable 1
write-vxi-register $CurrentVXIModule.GIR.DCR.DataXfer1.Enable 1
write-vxi-register $CurrentVXIModule.GIR.DCR.DataXfer2.Enable 0



#    start the GIR DSP Sliding Scale calibration.

  write-vxi-register $CurrentVXIModule.GIR.DSP.FilterMode 0
  write-vxi-register $CurrentVXIModule.GIR.DSP.StartDSP 1

# It is extremely important to keep 1 second after the DSP start so that the calibration can take place before returning 
# the parameters to their initial values.

after 1500

# returning the parameters to their initial values.


   write-vxi-register $CurrentVXIModule.GIR.DSP.StartDSP 0

#    flush FIFOs to reset adc_coding-deadtime but you need to disable dma2dsp flag because
# a start readout is generated when you reset the FIFO


write-vxi-register $CurrentVXIModule.GIR.DCR.DataXfer1.Enable 0

   write-vxi-register $CurrentVXIModule.FIFO.Reset 0
   write-vxi-register $CurrentVXIModule.FIFO.Reset 1
   write-vxi-register $CurrentVXIModule.FIFO.Reset 0

   write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 1

after 550

   write-vxi-register $CurrentVXIModule.GIR.DCR.ADCSSE 0
   write-vxi-register $CurrentVXIModule.CRC.DspSSCalibrateEn 0
   write-vxi-register $CurrentVXIModule.GIR.DSP.SSCalibrateEn 0

 write-vxi-register $CurrentVXIModule.XtalA.RCR $rcrA 
 write-vxi-register $CurrentVXIModule.XtalB.RCR $rcrB 
 write-vxi-register $CurrentVXIModule.XtalC.RCR $rcrC 
 write-vxi-register $CurrentVXIModule.XtalD.RCR $rcrD 
 write-vxi-register $CurrentVXIModule.CRC $CRCSTATUS
 write-vxi-register $CurrentVXIModule.GIR.DCR $DCRSTATUS
 write-vxi-register $CurrentVXIModule.GIR.DSP.Control $DSPCONTROLSTATUS
 


}



proc click-ssabort {} {
global CurrentVXIModule

#STOP DSP calibration acquisition

# reset DSP GIR
   write-vxi-register $CurrentVXIModule.GIR.DSP.StartDSP 0
   write-vxi-register $CurrentVXIModule.GIR.DSP.ResetDSP 1

write-vxi-register $CurrentVXIModule.GIR.DCR.ADCSSE 0
write-vxi-register $CurrentVXIModule.CRC.DspSSCalibrateEn 0
write-vxi-register $CurrentVXIModule.GIR.DSP.SSCalibrateEn 0


write-vxi-register $CurrentVXIModule.GIR.DCR.DSP_Enable 0
write-vxi-register $CurrentVXIModule.GIR.DCR.DataXfer1.Enable 1


}
