#    part of the Diagnostic task for testing GIR DSP functions
#    this is visumemext.tcl
global moduleindex card
  set visumemextaddr  0x0
  set visumemextwords 0x10

  set CHMEMEXT 0x80000

  set visumemextp1exists 0

  :frame [self frame-name].visumemext :label "Display External Memory" :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" :resize F

    :panel VISUMEMEXTP1 :layout T :padx 10 :pady 10
     :layout H; :col-gap 10; :row-gap 10
     :text     MODULE    :label "Current MODULE:" :deaf T :w 4 :bold T :value $moduleindex
     :text     CARD    :label "Current CARD:" :deaf T :w 8 :bold T :value $card

    :panel VISUMEMEXTP2 :layout T :padx 10 :pady 10
     :layout V; :col-gap 10; :row-gap 10
     :text VISUMEMEXTADDR    :label "Address Offset"  :value $visumemextaddr   :valuex 15c  :w 12
     :text VISUMEMEXTWORDS   :label "Words to read"   :value $visumemextwords  :valuex 15c  :w 12
       :message VISUMEMEXTM1 :label "Memory Contents" :bold T
       :row-gap 0
       :message VISUMEMEXTM2  :label "Address Offset: SRAM Address: DATA"
       :galley VISUMEMEXTINFO :rows 18 :cols 30 :deaf T
       :row-gap 5
       :button VISUMEMEXTREAD :label "Read Memory"  :command  do_visumemextdisplay
       :layout H; :col-gap 10
       :button VISUMEMEXTCLR  :label "Clear Window" :command ":modify VISUMEMEXTINFO :append F"
  

   :show T




proc click-visumemextaddr {v} {
   global  visumemextaddr visumemextwords CHMEMEXT
   if {[scan-int $v] == $v && $v >= 0 && $v < 0x7ffff} then {
      if {[expr $v + $visumemextwords] <= $CHMEMEXT} then {set visumemextaddr $v}
   }
   :modify VISUMEMEXTADDR :value [format "0x%05x" $visumemextaddr]
}

proc click-visumemextwords {v} {
   global visumemextaddr visumemextwords CHMEMEXT
   if {[scan-int $v] == $v && $v >= 0 && $v <= 0x400} then {
      if {[expr $visumemextaddr + $v] <= $CHMEMEXT} then {set visumemextwords $v}
   }
   :modify VISUMEMEXTWORDS :value [format "0x%02x" $visumemextwords]
   do_visumemextdisplay
}

proc  do_visumemextdisplay {} {
   global visumemextp1exists
   global CurrentVXIModule
   global  visumemextaddr visumemextwords moduleindex card


   :modify VISUMEMEXTINFO :append F
   :modify MODULE :value $moduleindex
   :modify CARD :value $card

   set-footer [self frame-name].visumemext "Reading data from $CurrentVXIModule."
   set blocks [expr ($visumemextwords + 63) / 64]
   set words $visumemextwords
   for {set block 0} {$block < $blocks} {incr block} {
#    do a block read for 64 words or $words whichever is the smaller
      set offset [expr $block * 64 + $visumemextaddr]
      set vmeaddress [expr $offset * 4]
      if {$words < 64} then {set length $words} else {set length 64}
      modify-vxi-register $CurrentVXIModule.GIR.DSP.ExtMem "-o [expr $offset * 4] -l $length"
      set DataRAM [read-vxi-register $CurrentVXIModule.GIR.DSP.ExtMem]
      foreach word $DataRAM {
         :modify VISUMEMEXTINFO  :strings "[format "0x%05x" $vmeaddress] [format "0x%02x" $offset]: $word\n"
         incr offset
         incr vmeaddress 4
      }
      set words [expr $words - 64]
   }
   clear-footer [self frame-name].visumemext

   click-visumemextaddr [expr $visumemextaddr + $visumemextwords]
}

