
# gocce.tcl---GOCCE card setup

#    Dec 2001  first version for testing prototype cards   VP

set debug 0
set started 0

set frame GOCCE
set frametitle "GOCCE Card Setup"
set icontitle GOCCE

set chanlist {???}
set chanindex 0
set chansel 1

set seglist {XtalA XtalB XtalC XtalD}
set segindex 0
set segsel 15
set allsegments Xtal?


set defaultchanlist {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15}

set cardtype GOCCE
set chantype ""
set VXIGlobal ""


global chansel chanlist chanindex

#    The array "table" which is indexed by the "widget name" contains all the information needed
#    for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for register access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"


set table(CHANNEL) {channel widget->channel channel->widget nil
        nil nil nil nil nil nil nil 1 nil}
set table(SEGMENT) {segment int-widget->param param->int-widget nil
        nil nil nil nil nil nil nil 1 nil}
set table(ALLCHANS) {allchans int-widget->param param->int-widget nil nil nil nil nil nil nil nil 0 nil}
set table(ALLSEGS) {allsegs int-widget->param param->int-widget nil nil nil nil nil nil nil nil 0 nil}

set table(ENABLE) {enable int-widget->param param->int-widget "LT.Enable"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}

set table(ADDRE0) {addre0 widget->param param->hex-widget "Seg0.Energy.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Seg 0 Energy Address"}
set table(READOUTE0) {readoute0 int-widget->param param->int-widget "Seg0.Energy.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Seg 0 Energy Readout"}
set table(ADDRT0) {addrt0 widget->param param->hex-widget "Seg0.Time.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Seg 0 Time Address"}
set table(READOUTT0) {readoutt0 int-widget->param param->int-widget "Seg0.Time.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Seg 0 Time Readout"}
       
set table(ADDRE1) {addre1 widget->param param->hex-widget "Seg1.Energy.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Seg 1 Energy Address"}
set table(READOUTE1) {readoute1 int-widget->param param->int-widget "Seg1.Energy.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Seg 1 Energy Readout"}
set table(ADDRT1) {addrt1 widget->param param->hex-widget "Seg1.Time.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Seg 1 Time Address"}
set table(READOUTT1) {readoutt1 int-widget->param param->int-widget "Seg1.Time.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Seg 1 Time Readout"}
       
set table(ADDRE2) {addre2 widget->param param->hex-widget "Seg2.Energy.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Seg 2 Energy Address"}
set table(READOUTE2) {readoute2 int-widget->param param->int-widget "Seg2.Energy.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Seg 2 Energy Readout"}
set table(ADDRT2) {addrt2 widget->param param->hex-widget "Seg2.Time.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Seg 2 Time Address"}
set table(READOUTT2) {readoutt2 int-widget->param param->int-widget "Seg2.Time.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Seg 2 Time Readout"}
       
set table(ADDRE3) {addre3 widget->param param->hex-widget "Seg3.Energy.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Seg 3 Energy Address"}
set table(READOUTE3) {readoute3 int-widget->param param->int-widget "Seg3.Energy.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Seg 3 Energy Readout"}
set table(ADDRT3) {addrt3 widget->param param->hex-widget "Seg3.Time.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Seg 3 Time Address"}
set table(READOUTT3) {readoutt3 int-widget->param param->int-widget "Seg3.Time.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Seg 3 Time Readout"}
       
set table(DSPDACADJ) {dspdacadj int-widget->param param->int-widget "DSP.DAC.Adj"
       int-reg->param param->int-reg nil :text 6 nil nil 0 nil}
set table(DSPPOTADJ) {dsppotadj int-widget->param param->int-widget "DSP.POT.Adj"
       int-reg->param param->int-reg nil :text 6 nil nil 0 nil}
       
set table(PDSGATE) {pdsgate int-widget->param param->int-widget "PDSGate.Width"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "PDS Gate Width"}
set table(PDSDELAY) {pdsdelay int-widget->param param->int-widget "PDSGate.Delay"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "PDS Gate Delay"}
set table(VALSAMPLE) {valsample int-widget->param param->int-widget "ValSample"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Validation Sample"}
set table(WDOGSAMPLE) {wdogsample int-widget->param param->int-widget "WatchdogSample"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Watchdog Sample"}
set table(SSCOUNTER) {sscounter int-widget->param param->int-widget "SSCounter"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(SSPULSE) {sspulse int-widget->param param->int-widget "SSPulse"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
       
#    Common Control Register
set table(CRC) {crc int-widget->param param->int-widget "CRC"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
       
set table(CRC0) {crc0 int-widget->param param->int-widget "CRC.OpMode"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(CRC1) {crc1 int-widget->param param->int-widget "CRC.TDCStop"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(CRC2) {crc2 int-widget->param param->int-widget "CRC.ReadOutDisable"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(CRC3) {crc3 int-widget->param param->int-widget "CRC.GOCCEStart"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(CRC4) {crc4 int-widget->param param->int-widget "CRC.ScalersEnable"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(CRC5) {crc5 int-widget->param param->int-widget "CRC.Veto"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(CRC6) {crc6 int-widget->param param->int-widget "CRC.SSEnable"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(CRC7) {crc int-widget->param param->int-widget "CRC.SSMode"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(CRC8) {crc int-widget->param param->int-widget "CRC.GOCCEInhReqMode"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(CRC9) {crc int-widget->param param->int-widget "CRC.ScalersMode"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(CRC10) {crc int-widget->param param->int-widget "CRC.ResetScalers"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
       
#    Crystal Readout Control Register
set table(RCR) {rcr int-widget->param param->int-widget "RCR"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(TACENABLE) {tacenable int-widget->param param->int-widget "TAC.Enable"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(SPAREEN) {spareen int-widget->param param->int-widget "CRCR.Spare.En"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "CRCR Spare En"}
set table(SPSEGSEL) {spsegsel int-widget->param param->int-widget "CRCR.Spare.Setup" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "CRCR Spare Setup"}



#    Scalers
set table(SCALER0) {scaler0 int-widget->param param->int-widget "Seg0.Scaler"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(SCALER1) {scaler1 int-widget->param param->int-widget "Seg1.Scaler"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(SCALER2) {scaler2 int-widget->param param->int-widget "Seg2.Scaler"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(SCALER3) {scaler3 int-widget->param param->int-widget "Seg3.Scaler"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
       
set table(FTSAMPLE) {ftsample int-widget->param param->int-widget "FTSample"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "FT Sample"}



set table(DTDTHRESH0) {dtdthresh0 int-widget->param param->int-widget "DTD.Thresh0"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "DTD THRESHOLD0"}
set table(DTDTHRESH1) {dtdthresh1 int-widget->param param->int-widget "DTD.Thresh1"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "DTD THRESHOLD1"}
set table(DTDTHRESH2) {dtdthresh2 int-widget->param param->int-widget "DTD.Thresh2"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "DTD THRESHOLD2"}
set table(DTDTHRESH3) {dtdthresh3 int-widget->param param->int-widget "DTD.Thresh3"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "DTD THRESHOLD3"}





set table(ENABLESEG0) {enableseg0 int-widget->param param->int-widget "Seg0.Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Seg 0 Time Readout"}
set table(ENABLESEG1) {enableseg1 int-widget->param param->int-widget "Seg1.Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Seg 0 Time Readout"}
set table(ENABLESEG2) {enableseg2 int-widget->param param->int-widget "Seg2.Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Seg 0 Time Readout"}
set table(ENABLESEG3) {enableseg3 int-widget->param param->int-widget "Seg3.Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Seg 0 Time Readout"}




       
#    VXI Configuration Registers
set table(MODELCODE) {modcode str-widget->param param->hex-widget "VXI.ModelCode" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(SERIALNUM) {serialnum str-widget->param param->hex-widget "VXI.SerialNum" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(MODLEVEL) {modlevel str-widget->param param->hex-widget "VXI.ModLevel" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(MANID) {manid str-widget->param param->hex-widget "VXI.ManID" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(OFFSET) {offset str-widget->param param->hex-widget "VXI.Offset" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
   
set table(EEPROMSERIALNUM) {eepromserialnum str-widget->param param->hex-widget "EEPROM.SerialNum" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(EEPROMMODLEVEL) {eeprommodlevel str-widget->param param->hex-widget "EEPROM.ModLevel" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(EEPROMMANID) {eeprommanid str-widget->param param->hex-widget "EEPROM.ManID" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
   
#     GIR Module Control Register 
set table(LASTCARD) {lastcard int-widget->param param->int-widget "LastCard"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Last Card"}
set table(RESETFIFO) {resetfifo int-widget->param param->int-widget "FIFO.Reset"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Fifo Reset"}
set table(RESETDSP) {resetdsp int-widget->param param->int-widget "DSP.Reset"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "DSP Reset"}
set table(RESETGIR) {resetgir int-widget->param param->int-widget "ResetGIR"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "GIR Reset"}

#    GIR items

set table(GIRRCR)    {girrcr    int-widget->param param->hex-widget "GIR.RCR"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRVALACKTIMEOUTRESET) {girrocrvalacktimeoutreset logic-widget->param param->logic-widget "GIR.RCR.ValAck.TimeOutReset"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRREADOUTDISABLE)     {girreadoutdisable     logic-widget->param param->logic-widget "GIR.RCR.ReadOut.Disable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCREVNUMDATADISABLE) {girevnumdatadisable logic-widget->param param->logic-widget "GIR.RCR.EvNumData.Disable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRQSTAT) {girrocrqstat int-widget->param param->int-widget "GIR.RCR.QStat"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRPIPELINEENABLE) {girpipelineenable logic-widget->param param->logic-widget "GIR.RCR.PipeLine.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRCDTENABLE) {gircdtenable logic-widget->param param->logic-widget "GIR.RCR.CommonDeadTime.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCREXTENABLE) {girextenable logic-widget->param param->logic-widget "GIR.RCR.ExtReadout.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRDCR)    {girdcr    int-widget->param param->hex-widget "GIR.DCR"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRDCRDSPENABLE) {girdcrdspenable logic-widget->param param->logic-widget "GIR.DCR.DSP_Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRDCRSARDSPENABLE) {girdcrsardspenable logic-widget->param param->logic-widget "GIR.DCR.DataXfer1.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRDCRDSPFIFOENABLE) {girdcrdspfifoenable logic-widget->param param->logic-widget "GIR.DCR.DataXfer2.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRDCRSPECTRE) {girdcrspectre logic-widget->param param->logic-widget "GIR.DCR.Spectre"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRDCRSCALER) {girdcrscaler logic-widget->param param->logic-widget "GIR.DCR.Scaler"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRDCRADCSSE) {girdcradcsse logic-widget->param param->logic-widget "GIR.DCR.ADCSSE"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRROTSR)    {girrotsr    int-widget->param param->hex-widget "GIR.ROTSR"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRFIFOSTATUS)    {girrotsrfifostatus    int-widget->param param->hex-widget "GIR.ROTSR.FIFO.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRTEMPSTATUSGIR)    {girrotsrtempstatusgir    int-widget->param param->TEMP-widget "GIR.ROTSR.Temp.Status.GIR"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRTEMPSTATUS1)    {girrotsrtempstatus1    int-widget->param param->ATEMP-widget "GIR.ROTSR.Temp.Status1"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRTEMPSTATUS2)    {girrotsrtempstatus2    int-widget->param param->ATEMP-widget "GIR.ROTSR.Temp.Status2"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRREADTEMPHIGH)    {girtcrreadtemphigh    int-widget->param param->degree-widget "GIR.TCR.ReadTempHigh"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRREADTEMPLOW)    {girtcrreadtemplow    widget->param param->degree-widget "GIR.TCR.ReadTempLow"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRWRITETEMPHIGH)    {girtcrwritetemphigh    int-widget->param param->int-widget "GIR.TCR.WriteTempHigh"
                     degree-reg->param param->degree-reg 2 :text 4 nil nil 1 "Temp high"}

set table(GIRTCRWRITETEMPLOW)    {girtcrwritetemplow   int-widget->param param->int-widget "GIR.TCR.WriteTempLow"
                     degree-reg->param param->degree-reg 2 :text 4 nil nil 1 "Temp low"}

set table(GIRTCRREADTEMP)    {girtcrreadtemp    int-widget->param param->degree-widget "GIR.TCR.ReadTemp"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRREADCONFIG) {girtcrreadconfig  int-widget->param param->int-widget "GIR.TCR.ReadConfig"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
                     
set table(GIRTCRWRITECONFIG) {girtcrwriteconfig  int-widget->param param->int-widget "GIR.TCR.WriteConfig"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
                     
set table(GIRTCRREADCOUNTER) {girtcrreadcounter  int-widget->param param->int-widget "GIR.TCR.ReadCounter"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRREADSLOPE) {girtcrreadslope  int-widget->param param->int-widget "GIR.TCR.ReadSlope"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
                     
set table(GIRTCRSTARTCONVERT) {girtcrstartconvert  int-widget->param param->int-widget "GIR.TCR.StartConvert"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
                     
set table(GIRTCRSTOPCONVERT) {girtcrstopconvert  int-widget->param param->int-widget "GIR.TCR.StopConvert"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRROTSRVALACKTIMEOUTSTATUS) {girrotsrvalacktimeoutstatus  logic-widget->param param->logic-widget "GIR.ROTSR.ValAck.TimeOut.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRVALACKTIMEOUT)    {girvalacktimeout    slider-widget->param param->int-widget "GIR.ValAck.TimeOut"
                     unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}

proc degree-reg->param {p v} {global $p; set $p [scan-int $v]}
proc param->degree-reg {p v u} {return "[expr $v*$u]"}
proc param->degree-widget {p v u} {return "$p :value [expr $v/2]"}

proc param->TEMP-widget {p v u} {
#    insert-debug "param->TEMP-widget $p $v $u"
    switch $v {
       1  {set s higher}
       2  {set s lower}
       0  {set s ok}
       default {set s ??}
    }
    return "$p :value $s"
}

proc param->ATEMP-widget {p v u} {
#    insert-debug "param->TEMP-widget $p $v $u"
    switch $v {
       2  {set s higher}
       1  {set s lower}
       3  {set s ok}
       default {set s ??}
    }
    return "$p :value $s"
}

#    register selection for parameter save function

set registersavepatterns {GIR.DCR GIR.RCR  GIR.ValAck.TimeOut MCR_GIR
  PDSGate.Width PDSGate.Delay ValSample WatchdogSample CRC 
  Xtal?.FTSample Xtal?.RCR Xtal?.Seg?.Enable Xtal?.DTD.Thresh?
  Xtal?.Seg?.Energy.ROEnable Xtal?.Seg?.Time.ROEnable Xtal?.LT.Enable Xtal?.TAC.Enable
  Xtal?.CRCR.Spare.Enable Xtal?.CRCR.Spare.Setup LastCard
}

# inspection tables must be in same order as entries in the :choice-stacks
# this is achieved by using these tables when generating the choices
# index number returned maps directly to the signal number to be written to 
# the Signal Select register

set insp_table(MUX-AI1) {"Insp.A1" AI}
set insp_table(MUX-AI2) {"Insp.A2" AI}
set insp_table(MUX-DI1) {"Insp.D1" DI}
set insp_table(MUX-DI2) {"Insp.D2" DI}

set insp_menu(MUX-AI1) analogueinsptable
set insp_menu(MUX-AI2) analogueinsptable
set insp_menu(MUX-DI1) digitalinsptable
set insp_menu(MUX-DI2) digitalinsptable


set inspection_widgetnames {MUX-AI1 MUX-AI2 MUX-DI1 MUX-DI2}
set inspection_regnames    {Insp.A1 Insp.A2 Insp.D1 Insp.D2}

#    the inspection line tables are in parallel
#    for channel select * implies value determined by adc channel
#    for parameter select * implies disconnect

set analogueinsptable {Disconnected
      PDS_Segment_0 LA_Segment_0 TFA_Segment_0 Analogue_In_Segment_0
      PDS_Segment_1 LA_Segment_1 TFA_Segment_1 Analogue_In_Segment_1
      PDS_Segment_2 LA_Segment_2 TFA_Segment_2 Analogue_In_Segment_2
      PDS_Segment_3 LA_Segment_3 TFA_Segment_3 Analogue_In_Segment_3
}

set AI-ChanSelect {0 * * * * * * * * * * *  *  *  *  *  *}
set AI-Param      {* 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15}

set digitalinsptable {Disconnected
        DDS0 DDS1 DDS2 DDS3 PDS_Gate PDS_Reset FT_Sample Val_Sample BLR_Out Encod_Command
        ADC_CVT ADC_Busy ADC_Clk ADC_Coding End_ADC_Rdt Timeout_Rst TDC_Start DtReady Renout AddRam_Run0 VETO_Flag ADC_Shift LT_Reset_Out
        Fast_Trigger Validation Inhibit_Action Renin Orvalack Startreadout Salti_Dtready Salti_Dtack LT_RESET_IN Wr_Strobe
        Resetfifo SS_DATA SS_CLK SS_Strobe SS_Link_Clk SS_Link_Oe SS_Link_Ack SS_Link_Data0 SS_Link_Data1 SS_Link_Data2 SS_Link_Data3 OR_CFD OR_VETO 
        StopCounter Latch_Seg_Pat Scaler_Cnt_Ce Wr_Scaler_SRAM Ld_Scaler_oldVal Incr_Scaler Wr_Scaler Reset_Scaler Start_Reset_Scaler
        Oe_Scaler
        Fast_Trigger Inhibit_Action Validation Event_Reject FIFO_RENIN
        OrValack DeadTime StartReadout SALTI_Renin SALTI_Dtready SALTI_Dtack SALTI_Last_Pass CLKWF ENWF Flag0_DSP Flag1_DSP
        Flag2_DSP Flag3_DSP Irq0_DSP Irq1_DSP
        Inhibit_Req AS*(VME) DS(VME) R/W*(VME) ModRoco CardRenin* BLTACK(Card) BLTACK(Bus) FDTACK DTACK*(VME) Decod_Sel OEData_Card
        LT_Reset* ClkB-fifo ENB_FIFO EmptyFIFO ResetFifo Sysclk
        Link_CE DMA_Req DMA_Grant Link4_Start Link4_Ack Link54_Clk Link4_Dat0  Link4_Dat1 Link4_Dat2 Link4_Dat3
        Dtack_VXI OE_DSP_Run Event_Counter_CE Readout_Evt_Fault Readout_Evt_Match Wr_DSP RD_DSP CS_DSP OE_ADD_DSP
        MS1_DSP HBR_DSP HBG_DSP CS_Sram1 WE_Sram1 OE_Sram1
}



set DI-ChanSelect {0 * * * * * * * * * * * * * * * * * * * * * * * 
                       5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5
                     6 6 6 6 6 6 6 6 6 6
        32 32 32 32 32
        32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
        32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
        32 32 32 32 32 32 32 32 32 32 32 32
        32 32 32 32 32 32 32 32 32 32 32 32 32
}

set DI-Param      {* 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23
                     1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23
                     1 2 3 4 5 6 7 8 9 10
        1 2 3 4 5
        6 7 8 9 10 11 12 13 14 15 16 17 18 19 20
        21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38
        39 40 41 42 43 44 45 46 47 48 49 50
        51 52 53 54 55 56 57 58 59 60 61 62 63
}

set digitalinspmenu {Disconnected
        DDS0 DDS1 DDS2 DDS3 PDS_Gate PDS_Reset FT_Sample Val_Sample BLR_Out Encod_Command
        ADC_CVT ADC_Busy ADC_Clk ADC_Coding End_ADC_Rdt Timeout_Rst TDC_Start DtReady Renout AddRam_Run0 VETO_Flag ADC_Shift LT_Reset_Out 
        {"Common Signals"
        Fast_Trigger Validation Inhibit_Action Renin Orvalack Startreadout Salti_Dtready Salti_Dtack LT_RESET_IN Wr_Strobe
        Resetfifo SS_DATA SS_CLK SS_Strobe SS_Link_Clk SS_Link_Oe SS_Link_Ack SS_Link_Data0 SS_Link_Data1 SS_Link_Data2 SS_Link_Data3 OR_CFD OR_VETO
        StopCounter Latch_Seg_Pat Scaler_Cnt_Ce Wr_Scaler_SRAM Ld_Scaler_oldVal Incr_Scaler Wr_Scaler Reset_Scaler Start_Reset_Scaler
        Oe_Scaler
        }
        {"Trigger Signals"
        Fast_Trigger Inhibit_Action Validation Event_Reject FIFO_RENIN
        }
        {"ReadOut GOCCE to GIR"
        OrValack DeadTime StartReadout SALTI_Renin SALTI_Dtready SALTI_Dtack SALTI_Last_Pass CLKWF ENWF Flag0_DSP Flag1_DSP
        Flag2_DSP Flag3_DSP Irq0_DSP Irq1_DSP
        }
        {"VXI Readout"
        Inhibit_Req AS*(VME) DS(VME) R/W*(VME) ModRoco CardRenin* BLTACK(Card) BLTACK(Bus) FDTACK DTACK*(VME) Decod_Sel OEData_Card
        LT_Reset* ClkB-fifo ENB_FIFO EmptyFIFO ResetFifo Sysclk
        }
        {"DSP Interface"
        Link_CE DMA_Req DMA_Grant Link4_Start Link4_Ack Link54_Clk Link4_Dat0  Link4_Dat1 Link4_Dat2 Link4_Dat3
        Dtack_VXI OE_DSP_Run Event_Counter_CE Readout_Evt_Fault Readout_Evt_Match Wr_DSP RD_DSP CS_DSP OE_ADD_DSP
        MS1_DSP HBR_DSP HBG_DSP CS_Sram1 WE_Sram1 OE_Sram1
        }
}

loadsource common.vxi


proc GIRbutton {} {
      :menubutton GIR         :label "GIR"          :strings [list "GIR Setup & Status" "GIR DSP Control"] :command click-GIR
}

proc start-GIR {} {
#  display GIR sub frame
   global girvisible girframe
   if {$girvisible==0} then {make-GIR} else {open-frame $girframe}
   click-redisplay
} 

proc click-GIR {w c i} {
    global cardtype
    switch $c {
      "GIR Setup & Status"      {start-GIR}
      "GIR DSP Control"         {inform gir "start_with_card $cardtype"}
   }
}

proc update-scalers {} {
#    update-widget SCALER0
#    update-widget SCALER1
#    update-widget SCALER2
#    update-widget SCALER3
     Redisplay
}




proc click arg {
   global debug userselection allchans 
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]
   if {$c==":quit"} then {return [click-quit $f]}
   switch -glob $w {
      *REDISPLAY  {click-redisplay}
      ENGINEERING {click-$v}
      
      CHANNEL     {click-channel $v}
      SEGMENT     {click-segment $v}
      ALLCHANS    {click-whichchans $v}
      ALLSEGS     {click-whichsegs $v}

      CHANSEL     {click-chanselection $v}
      SEGSEL      {click-segselection $v}

      PARAM       {click-param $v}
      MUX-*       {click-inspection $w $i}
      SCALERS     {update-scalers}
      default   {
          if {$allchans < 0} then {set userselection 1}
             click-on $w $v
             set userselection 0
      }
   }
}


set electronicsframe [self frame-name].electronics
set electronicsvisible 0

set expertframe [self frame-name].expert
set expertvisible 0

set girframe [self frame-name].gir
set girvisible 0


proc start-EXPERT {} {
   global expertvisible expertframe
   if {$expertvisible==0} then {make-expert} else {open-frame $expertframe}
   click-redisplay
}
   
proc make-frame1 {} {
  global env chanlist seglist
  global analogueinsptable digitalinspmenu

  :frame [self frame-name] :label "[self frame-title]" :show-footer T :resize F \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]"

   :panel P1 :layout T :padx 10 :pady 5
     :layout H; :row-gap 10; :col-gap 10
      :choice-stack CHANNEL :label "Current Detector:" :strings $chanlist :valuex 16c
      :choice-stack SEGMENT :label "Current Crystal:"  :strings $seglist  :valuex 16c
      :hskip 10
      :checkbox ENABLE :label "LT Enable:"
      :next-row T
      :choice ALLCHANS :label "Act on Detectors?" :valuex 16c :strings [list Current All Select] :value 0
      :choice ALLSEGS  :label "Act on Crystals?"  :valuex 16c :strings [list Current All Select] :value 0
      :next-row T
      :choice SPSEGSEL		:label "Segment Replaced"	:strings [list 0 1 2 3] :value 0
      :checkbox SPAREEN  	:label "Spare Enable" 	:valuex 26c


   :panel P2 :layout T :padx 10 :pady 10
     :layout H; :col-gap 5;  :row-gap 5
      :message M1 :label "Readout Enable" :bold T
      :next-row T
      :checkbox READOUTE0   :label "Segment 0  -  Energy"   :valuex 20c
      :checkbox READOUTT0   :label "Time"
      :checkbox READOUTE1   :label "Segment 1  -  Energy"   :valuex 20c
      :checkbox READOUTT1   :label "Time"
      
      :next-row T
      :checkbox READOUTE2   :label "Segment 2  -  Energy"   :valuex 20c
      :checkbox READOUTT2   :label "Time"
      :checkbox READOUTE3   :label "Segment 3  -  Energy"   :valuex 20c
      :checkbox READOUTT3   :label "Time"

   :panel P4 :layout T :padx 10 :pady 10
     :layout V; :row-gap 5
      :slider PDSGATE      :label "PDS Gate Width:"       :min 0 :max 255   :valuex 20c
      :slider PDSDELAY     :label "PDS Gate Delay:"       :min 0 :max 255   :valuex 20c
      :slider VALSAMPLE    :label "Validation Sample:"    :min 0 :max 255   :valuex 20c
      :slider WDOGSAMPLE   :label "Watchdog Sample:"      :min 0 :max 255   :valuex 20c
      :checkbox TACENABLE   :label "TAC Enable" :valuex 20c

      :vskip 10
      :slider FTSAMPLE    :label "FT Sample:"    :min 0 :max 255 :valuex 20c

   :panel P99 :layout T :padx 10 :pady 10
     :layout H; :col-gap 5;  :row-gap 5
      :message M1 :label "Segment Enable Registers" :bold T
      :next-row T

      :slider DTDTHRESH0    :label "DTD Threshold0:"    :min 0 :max 255 :valuex 20c
      :checkbox ENABLESEG0   :label "Enable Seg 0"   
      :next-row T

      :slider DTDTHRESH1    :label "DTD Threshold1:"    :min 0 :max 255 :valuex 20c
      :checkbox ENABLESEG1   :label "Enable Seg 1"
      :next-row T

      :slider DTDTHRESH2    :label "DTD Threshold2:"    :min 0 :max 255 :valuex 20c
      :checkbox ENABLESEG2   :label "Enable Seg 2"   
      :next-row T

      :slider DTDTHRESH3    :label "DTD Threshold3:"    :min 0 :max 255 :valuex 20c
      :checkbox ENABLESEG3   :label "Enable Seg 3"




      
   :panel P3 :layout T :padx 10 :pady 10
     :layout H; :col-gap 5;  :row-gap 5
      :message M2 :label "Scalers" :bold T
      :hskip 50
      :button SCALERS :label "Update"
      
      :next-row T
      :text SCALER0  :label "Seg 0" :w 8  :read-only T
      :text SCALER1  :label "Seg 1" :w 8  :read-only T
      :text SCALER2  :label "Seg 2" :w 8  :read-only T
      :text SCALER3  :label "Seg 3" :w 8  :read-only T



   :panel P5 :layout T :padx 10 :pady 10
      :layout H; :col-gap 10; :row-gap 10
      :menubutton MUX-AI1 :label "Analogue Inspection 1:" :w 22 :menu $analogueinsptable
      :message MUX-AI1-USE   :label ""
      :next-row T
      :menubutton MUX-AI2 :label "Analogue Inspection 2:" :w 22 :menu $analogueinsptable
      :message MUX-AI2-USE   :label ""
      :next-row T
      :menubutton MUX-DI1 :label "Digital Inspection 1:"  :w 22 :menu $digitalinspmenu
      :message MUX-DI1-USE   :label ""
      :next-row T
      :menubutton MUX-DI2 :label "Digital Inspection 2:"  :w 22 :menu $digitalinspmenu
      :message MUX-DI2-USE   :label ""

   :panel P6 :layout B :padx 10 :after FOOTER
     :layout H; :col-gap 20
      :button REDISPLAY
      :button EXPERT   :label "Expert Setup" :command start-EXPERT
      GIRbutton
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics software]
      :button HELP  
   
 :show T
}


proc make-electronics {} {
  global env electronicsframe electronicsvisible

  :frame "$electronicsframe" :label "GOCCE Electronics" :resize F :transient T

   :panel P20 :layout T :padx 5 :pady 5
      :layout H; :row-gap 5
      :message VXIREGISTER       :label "VXI Registers:"  :bold T        :valuex 20c
    :next-row T
      :text MODELCODE     :label "Model Code:" :w 6  :read-only T        :valuex 20c
    :next-row T
      :text MODLEVEL       :label "Modification Level:" :w 6 :read-only T :valuex 20c
      :text EEPROMMODLEVEL :label "Analogue card Mod Level:" :w 6 :read-only T :valuex 25c
    :next-row T
      :text MANID         :label "Manufacturer ID:" :w 6  :read-only T   :valuex 20c
      :text EEPROMMANID   :label "Analogue card Man ID:" :w 6  :read-only T   :valuex 25c
    :next-row T
      :text SERIALNUM         :label "Serial Number:" :w 6 :read-only T      :valuex 20c
      :text EEPROMSERIALNUM   :label "Analogue card Ser Number:" :w 6 :read-only T      :valuex 25c
    :next-row T
      :text OFFSET         :label "Offset:" :w 6 :read-only T      :valuex 20c
      
    :next-row T
      :message GMCR              :label "GIR Control Register:" :bold T  :valuex 20c 
    :next-row T
      :checkbox LASTCARD  :label "Last Card:"                            :valuex 20c
      :checkbox RESETDSP       :label "Reset DSP:"                        :valuex 20c
    :next-row T
      :checkbox RESETGIR       :label "Reset GIR:"                        :valuex 20c
      :checkbox RESETFIFO      :label "Reset Fifo:"                      :valuex 20c
      
    :next-row T
      :text DSPDACADJ  :label "DSP DAC Adjustment"  :w 6 :valuex 20c
      :text DSPPOTADJ  :label "DSP Pot Adjustment"  :w 6 :valuex 20c
      
    :next-row T
      :message ADDRM   :label "Address Initialisation"   :bold T  :valuex 20c
    :next-row T
      :text ADDRE0   :label "Segment 0  -  Energy"   :w 6  :read-only T  :valuex 20c
      :text ADDRT0   :label "Segment 0  -  Time"  :w 6  :read-only T  :valuex 20c
      :next-row T
      :text ADDRE1   :label "Segment 1  -  Energy"   :w 6  :read-only T  :valuex 20c
      :text ADDRT1   :label "Segment 0  -  Time"  :w 6  :read-only T  :valuex 20c
      :next-row T
      :text ADDRE2   :label "Segment 2  -  Energy"   :w 6  :read-only T  :valuex 20c
      :text ADDRT2   :label "Segment 0  -  Time"  :w 6  :read-only T  :valuex 20c
      :next-row T
      :text ADDRE3   :label "Segment 3  -  Energy"   :w 6  :read-only T  :valuex 20c
      :text ADDRT3   :label "Segment 0  -  Time"  :w 6  :read-only T  :valuex 20c
    

  :show T
 set electronicsvisible 1
}


proc make-expert {} {
  global env expertframe expertvisible

  :frame "$expertframe" :label "GOCCE Card Setup (expert)" :resize F :transient T

   :panel P21 :layout T :padx 5 :pady 5
      :layout V; :row-gap 10; :col-gap 10
      
      :message CRC  :label "Common Register Control" :bold T  :valuex 30c
      :choice CRC0  :label "Operation Mode"        :strings [list "4 independent channels" "1 channel"]       :valuex 20c :w 20
      :choice CRC1  :label "TDC Mode"              :strings [list "TDC Stop from FT" "DTD Stop from CFD_OR"]  :valuex 20c :w 20
      :choice CRC2  :label "Salti Readout"         :strings [list Enable Disable]                             :valuex 20c :w 20
      :choice CRC3  :label "GOCCE Start Mode"      :strings [list "ECC CFD" "GOCCE DTD"]                      :valuex 20c :w 20
      :choice CRC4  :label "Scalers"               :strings [list Disable Enable]                             :valuex 20c :w 20
      :choice CRC5  :label "Veto"                  :strings [list Mark Reject]                                :valuex 20c :w 20
      :choice CRC6  :label "ADC Sliding Scale"     :strings [list Disable Enable]                             :valuex 20c :w 20
      :choice CRC7  :label "Sliding Scale value"   :strings [list Minimum Maximum] :valuex 20c :w 20
      :choice CRC8  :label "GOCCE Inhibit request" :strings [list Disable Enable]  :valuex 20c :w 20
      :choice CRC9  :label "Latch DTD Scalers"     :strings [list Enable Disable]  :valuex 20c :w 20
      :choice CRC10 :label "Reset Scalers"         :strings [list Disable Enable]  :valuex 20c :w 20
      
      :layout H
      :next-row T
      :text SSCOUNTER  :label "Sliding Scale value counter"  :valuex 25c :w 8
      :button SSPULSE  :label "Simulate SS pulse"

  :show T
 set expertvisible 1
}


proc make-GIR {} {
  global env girvisible girframe

set col1 40c

  :frame "$girframe" :label "GOCCE GIR Status" :show-footer T :resize F :transient T 

  :panel PANEL1 :layout T :padx 5 :pady 5
    :layout V; :row-gap 5; :col-gap 5

      :message M1 :label "DSP Control Register" :bold T
      :checkbox GIRDCRDSPENABLE      :label "Data Xfer GOCCE => DSP Enable" :valuex 30c
      :checkbox GIRDCRSARDSPENABLE   :label "Data Xfer DSP => VXI Enable"   :valuex 30c
      :checkbox GIRDCRDSPFIFOENABLE  :label "DSP Link4 Transfer Enable"     :valuex 30c
      :checkbox GIRDCRSPECTRE        :label "Enable Spectra"                :valuex 30c
      :checkbox GIRDCRSCALER         :label "Enable Scaler"                 :valuex 30c
      :checkbox GIRDCRADCSSE         :label "GOCCE ADC Sliding Scale Enable" :valuex 30c

  :panel PANEL2 :layout T :padx 5 :pady 5
    :layout V; :row-gap 5; :col-gap 5
      :message M2 :label "GIRV5 Readout Control Register" :bold T
      :checkbox GIRROCRVALACKTIMEOUTRESET :label "Enable Valack Timeout Reset" :valuex 30c
      :checkbox GIRROCRREADOUTDISABLE     :label "Disable GIRV5 Readout"       :valuex 30c
      :checkbox GIRROCREVNUMDATADISABLE   :label "Event Number Readout OFF"    :valuex 30c
      :checkbox GIRROCRQSTAT              :label "Qstat Enable"                :valuex 30c
      :checkbox GIRROCRPIPELINEENABLE     :label "Pipeline Readout Enable"     :valuex 30c
      :checkbox GIRROCRCDTENABLE          :label "CDT Readout Disable"         :valuex 30c
      :checkbox GIRROCREXTENABLE          :label "External Readout Enable"     :valuex 30c

  :panel PANEL3 :layout T :padx 5 :pady 5
    :layout H; :row-gap 5; :col-gap 5
      :message M3 :label "GIRV5 Readout Status Register"  :bold T
      :next-row T
      :hskip 10
      :text    GIRROTSR            :label "Value"  :w 6
      :hskip 20
      :text    GIRROTSRFIFOSTATUS  :label "Fifo Status:" :w 6
      :next-row T
      :hskip 10
      :message M4 :label "Valack Timeout:" :bold T 
      :next-row T
      :checkbox GIRROTSRVALACKTIMEOUTSTATUS     :label "Asserted:" :deaf T
      :slider  GIRVALACKTIMEOUT          :label "(ns):"  :min 0 :max 2000000 :resolution 62

      :next-row T
      :vskip 10
      :message M5 :label "Temperature Register"  :bold T
      :next-row T
      :hskip 10
      :message M6 :label "Analog"  :bold T
      :text    GIRROTSRTEMPSTATUS1    :label "Sensor 1:"   :valuex 10c :w 6
      :text    GIRROTSRTEMPSTATUS2    :label "Sensor 2:"   :valuex 10c :w 6

      :next-row T
      :hskip 10
      :message M7 :label "GIR"  :bold T
      :next-row T
      :col-gap 15
      :text    GIRTCRREADTEMP        :label "Temp (C):"    :read-only T :w 6 :valuex 12c
      :text    GIRROTSRTEMPSTATUSGIR :label "Status"       :read-only T :w 6
      :next-row T
      :message M8  :label "Thresh : "  :valuex 12c :bold T
      :message M9  :label "Read : "   :bold T
      :message M10 :label "Write : "  :bold T
      :message M12 :label "Alarm : "  :bold T

      :next-row T
      :text     GIRTCRREADTEMPHIGH      :label "High (C): " :read-only T :w 6 :valuex 12c
      :text     GIRTCRWRITETEMPHIGH     :label "" :w 6
      :hskip 25
      :checkbox GIRTCRREADALARMHIGH     :label "" :deaf T :colours [list green red]
      :next-row T
      :text     GIRTCRREADTEMPLOW      :label "Low (C):  " :read-only T :w 6 :valuex 12c
      :text     GIRTCRWRITETEMPLOW     :label "" :w 6
      :hskip 25
      :checkbox GIRTCRREADALARMLOW     :label "" :deaf T :colours [list green blue]
      :next-row T

      :col-gap 30
      :button GIRREDISPLAY  :label Redisplay

  :show T
  set girvisible 1
}

proc make-chanSELframe {} {
  global chansel chanlist

   :frame CHANSEL-FRAME :label "GOCCE Detector Selection"  :show-footer F :resize F :transient T
   :panel CHANSEL-PANEL :layout T
   :choice CHANSEL :exclusive F :strings $chanlist :value $chansel
   :show T
}  

proc make-segSELframe {} {
  global segsel seglist

   :frame SEGSEL-FRAME :label "GOCCE Crystal Selection"  :show-footer F :resize F :transient T
   :panel SEGSEL-PANEL :layout T
   :choice SEGSEL :exclusive F :strings $seglist :value $segsel
   :show T
}  


