#    hist task code overlay for detector type "bgoball"

set lowchannel 0
set highchannel 17
set maxchannel  17
set qualifier 1

set bgonames {Energy TAC Pattern}
set qnames   {q0 q1 q2 q3}
set qualnames {0 1 2 3 0+2}

set bgo 0

proc make-overlaypanel {} {
   global bgonames 

      :layout V; :row-gap 10; :col-gap 0

      :message DET-M1  :label "Bgo Ball detector overlay applied"

      :number DET-LOW  :label "Low channel:"  :w 5 :valuex 15c
      :number DET-HIGH :label "High channel:" :w 5 :valuex 15c

      :choice DET-BGO  :label "ADC - BGO:" :valuex 15c :exclusive F :strings $bgonames :value 0
}


#    this proc handles events from widgets created in the proc make-overlaypanel
#    The widgets DET-LOW; DET-HIGH and DET-QUAL are handled in the main click procedure
#    and are not required here

proc click-overlay {w v} {

   switch -glob $w {
      DET-BGO          {click-adc $v bgo}
      default      {puts stdout $arg}
   }
}

proc repaint_overlay {} {
   global spectrumlist
   global bgo

   if {[llength $spectrumlist] > 0} then {
       :modify DET-BGO :value 0
   } else {
       :modify DET-BGO :value $bgo
   }
}


proc get-spectrum-list {} {
        global spectrumlist
        global bgonames bgo
        global lowchannel highchannel

        if {$spectrumlist != {}} then {return $spectrumlist};  # return names selected from spectrum list

        set list {}

        for {set i $lowchannel} {$i<=$highchannel} {incr i} {
            foreach adc [list-take $bgonames [bits-in $bgo]] {lappend list BgoBall$i.$adc}
        }
       return $list
}

proc range-of {n} {

        set fields [split $n "."]
        if {[string match "Pattern" [second $fields]]} then {return 0x800};  # BGO Pattern item
        return 0x2000;  #  everything else
}
