#    hist task code overlay for detector type "euclides"


set lowchannel 0
set highchannel 39
set maxchannel 39
set qualifier 1

set itemnames  {E DE TAC CO}

set item 0

set segnames {a b c d}
set seg 15


proc make-overlaypanel {} {
   global segnames seg
   global itemnames bgonames rdoutnames qnames

    :layout V; :row-gap 10; :col-gap 0

      :message DET-M1  :label "Euclides detector overlay applied"

      :number DET-LOW  :label "Low channel:"   :w 5 :valuex 15c
      :number DET-HIGH :label "High channel:"  :w 5 :valuex 15c

      :choice DET-SEG  :label "Segment:"       :valuex 15c :exclusive F :strings $segnames :value $seg

      :choice DET-ITEM  :label "item:"  :valuex 15c :exclusive F :strings $itemnames :value 0
}



#    this proc handles events from widgets created in the proc make-overlaypanel
#    The widgets DET-LOW; DET-HIGH and DET-QUAL are handled in the main click procedure
#    and are not required here

proc click-overlay {w v} {

   switch -glob $w {
      DET-ITEM          {click-adc $v item}
      DET-SEG          {click-segment $v}
      default      {puts stdout $arg}
   }
}

proc repaint_overlay {} {
   global spectrumlist
   global item bgo seg rdout qualifier

   if {[llength $spectrumlist] > 0} then {
       :modify DET-ITEM :value 0
       :modify DET-SEG :value 0
   } else {
       :modify DET-ITEM :value $item
       :modify DET-SEG :value $seg
   }
}


proc get-spectrum-list {} {
        global spectrumlist
        global itemnames item bgo
        global seg segnames
        global lowchannel highchannel

        if {$spectrumlist != {}} then {return $spectrumlist};  # return names selected from spectrum list

        set seglist [list-take $segnames  [bits-in $seg]]

        set list {}

        for {set i $lowchannel} {$i<=$highchannel} {incr i} {
# append spectrum names
           foreach adc [list-take $itemnames [bits-in $item]] {
              foreach s $seglist {lappend list Euclides$i.$s.$adc}
           }
        }
        return $list
}

proc range-of n {return 4096}

proc click-segment v {
   global seg spectrumlist
   set seg $v
   if {$spectrumlist!={}} then {paint-histlist; repaint}
}
