#    hist task code overlay for detector type "vre"


set lowchannel 0
set highchannel 255
set maxchannel 255
set qualifier 1

set vrenames  {StartSub EvNum.MSW EvNum.LSW EndSub}
set qnames   {q0 q1 q2 q3}
set qualnames {0 1 2 3}

set vre 0


proc make-overlaypanel {} {
   global vrenames qnames

      :layout V; :row-gap 10; :col-gap 0

      :message DET-M1  :label "VRE detector overlay applied"

      :number DET-LOW  :label "Low channel:"   :w 5 :valuex 15c
      :number DET-HIGH :label "High channel:"  :w 5 :valuex 15c

      :choice DET-QUAL :label "Qualifier"  :valuex 15c :exclusive F :strings $qnames :value 1
      :choice DET-VRE  :label "Items"      :valuex  6c :exclusive F :strings $vrenames :value 0
}



#    this proc handles events from widgets created in the proc make-overlaypanel
#    The widgets DET-LOW; DET-HIGH and DET-QUAL are handled in the main click procedure
#    and are not required here

proc click-overlay {w v} {

   switch -glob $w {
      DET-VRE           {click-adc $v vre}
      default      {puts stdout $arg}
   }
}

proc repaint_overlay {} {
   global spectrumlist
   global vre qualifier

   if {[llength $spectrumlist] > 0} then {
       :modify DET-VRE  :value 0
       :modify DET-QUAL :value 0
   } else {
       :modify DET-VRE  :value $vre
       :modify DET-QUAL :value $qualifier
   }
}


proc get-spectrum-list {} {
        global spectrumlist
        global vrenames vre
        global qualifier qualnames
        global lowchannel highchannel

        if {$spectrumlist != {}} then {return $spectrumlist};  # return names selected from spectrum list

        set qlist   [list-take $qualnames [bits-in $qualifier]]

        set list {}

        for {set i $lowchannel} {$i<=$highchannel} {incr i} {
# append vre spectrum names
           foreach adc [list-take $vrenames [bits-in $vre]] {
              foreach q $qlist {lappend list VRE$i.$adc.q$q}
           }
        }
        return $list
}

proc range-of n {return 0x10000}
