# added make-chanlist to redisplay
# modified 090597 to remove the :read-only flags from the :messages.
#		 and to change the order of the set commands in the start proceedure
set debug 0
set started 0
set afterid 0
set frame RMLA
set frametitle "RM Logic Analyser"
set icontitle RMLA

set help_topic RMLA

set cardtype RM
set chantype ""

set chanlist {1 2 3 4 }
set chanindex 0

loadsource common.vxi

set server /$resource

set afterid ""

set RunMode 0
set RunState 0
set RunPeriod 500

set bits {0 1 X}
set posnlist {Pre Post}

set ladfinsp0 "Disconnected"
set ladfinsp1 "Disconnected"
set inspection_widgetnames { MUX-DI1 MUX-DI2 }
set inspection 1


# ------------------------------------------------------------------------------------------
# This following section will try and see if an RMLA is attached.
# first a list of all the registers and attributes 
#		register			type	attributes
set reglist(0)	{"LA.Run"                    "xExt" "-a0x8880 -prw -fd -l1 -b0"}
set reglist(1)	{"LA.Reset"                  "xExt" "-a0x8880 -prw -fd -l1 -b1"}
set reglist(2)	{"LA.FIFO.Full"              "xExt" "-a0x8880 -prw -fd -l1 -b2"}
set reglist(3)	{"LA.FIFO.Empty"             "xExt" "-a0x8880 -prw -fd -l1 -b3"}
set reglist(4)	{"LA.Trig.Position"          "xExt" "-a0x8880 -prw -fd -l1 -b5"}
set reglist(5)	{"LA.Triggered"              "xExt" "-a0x8880 -prw -fd -l1 -b6"}
set reglist(6)	{"LA.Int.Enable"             "xExt" "-a0x8880 -prw -fd -l1 -b7"}

set reglist(7)	{"LA.Trig.Pattern"           "xExt" "-a0x8881 -prw -fx"}
set reglist(8)	{"LA.Trig.Val1"              "xExt" "-a0x8881 -prw -fd -l1 -b0"}
set reglist(9)	{"LA.Trig.InhibitRequest"    "xExt" "-a0x8881 -prw -fd -l1 -b1"}
set reglist(10)	{"LA.Trig.Insp.D1"           "xExt" "-a0x8881 -prw -fd -l1 -b2"}
set reglist(11)	{"LA.Trig.Insp.D2"           "xExt" "-a0x8881 -prw -fd -l1 -b3"}
set reglist(12)	{"LA.Trig.Val3"              "xExt" "-a0x8881 -prw -fd -l1 -b4"}
set reglist(13)	{"LA.Trig.InhibitAction"     "xExt" "-a0x8881 -prw -fd -l1 -b5"}
set reglist(14)	{"LA.Trig.FT"                "xExt" "-a0x8881 -prw -fd -l1 -b6"}
set reglist(15)	{"LA.Trig.Ext"               "xExt" "-a0x8881 -prw -fd -l1 -b7"}

set reglist(16)	{"LA.Trig.DontCare"          "xExt" "-a0x8882 -prw -fx -i0xffff"}
set reglist(17)	{"LA.Trig.X.Val1"            "xExt" "-a0x8882 -prw -fd -l1 -b0"}
set reglist(18)	{"LA.Trig.X.InhibitRequest"  "xExt" "-a0x8882 -prw -fd -l1 -b1"}
set reglist(19)	{"LA.Trig.X.Insp.D1"         "xExt" "-a0x8882 -prw -fd -l1 -b2"}
set reglist(20)	{"LA.Trig.X.Insp.D2"         "xExt" "-a0x8882 -prw -fd -l1 -b3"}
set reglist(21)	{"LA.Trig.X.Val3"            "xExt" "-a0x8882 -prw -fd -l1 -b4"}
set reglist(22)	{"LA.Trig.X.InhibitAction"   "xExt" "-a0x8882 -prw -fd -l1 -b5"}
set reglist(23)	{"LA.Trig.X.FT"              "xExt" "-a0x8882 -prw -fd -l1 -b6"}
set reglist(24)	{"LA.Trig.X.Ext"             "xExt" "-a0x8882 -prw -fd -l1 -b7"}

set reglist(25)	{"LA.Trig.Place"             "xExt" "-a0x8883 -prw -fd "}

set reglist(26)	{"LA.Readout"                "xLAR" "-a0x8884"}
set reglist(27)	{"LA.Trace0"                 "xLAT" "-t0"}
set reglist(28)	{"LA.Trace1"                 "xLAT" "-t1"}
set reglist(29)	{"LA.Trace2"                 "xLAT" "-t2"}
set reglist(30)	{"LA.Trace3"                 "xLAT" "-t3"}
set reglist(31)	{"LA.Trace4"                 "xLAT" "-t4"}
set reglist(32)	{"LA.Trace5"                 "xLAT" "-t5"}
set reglist(33)	{"LA.Trace6"                 "xLAT" "-t6"}
set reglist(34)	{"LA.Trace7"                 "xLAT" "-t7"}
set reglisttotal 35			
# total number of registers in the RMLA list

set egallowstore $EGallow
set EGallow 0x20006			
# this for undefined register
set egresult -1

proc register-define { n } {
	global egresult	reglist resource chanlist chanindex
	set chan [lindex $chanlist $chanindex]
	set egresult [catch {EG "register :name '/[VXImodule2crate RM$chan]/RM$chan.[first $reglist($n)]' :class '[second $reglist($n)]' !new "} m]
        if {$m == ""} then {set egresult 0} else {set egresult 1}
}

proc register-undefine { n } {
	global egresult	reglist resource chanlist chanindex
	set chan [lindex $chanlist $chanindex]

	set egresult [catch {EG "register :name '/[VXImodule2crate RM$chan]/RM$chan.[first $reglist($n)]' !delete "} m ]
        if {$m == ""} then {set egresult 0} else {set egresult 1}
}

proc register-set-attributes { n } {
	global egresult	reglist resource chanlist chanindex
	set chan [lindex $chanlist $chanindex]

	set egresult [catch {EG "register :name '/$resource/RM$chan.[first $reglist($n)]' :object '[third $reglist($n)]' "} m
        if {$m == ""} then {set egresult 0} else {set egresult 1} ]
}

proc check-for-rmla {} {
	global egresult reglisttotal EGallow egallowstore reglist
# check the presence of an existing register
		set egallowstore $EGallow
		set EGallow 0x20006	
		register-define 0
		if {$egresult == 0 } then {				
# register  not defined , so we try for one 
			set EGallow 0x10004
			register-set-attributes 0
			set EGallow 0x2000a	
	 		set egresult [catch {read-vxi-reg [first $reglist(0)]} m]
                        if {$m == $EGallow} then {set egresult 1} else {set egresult 0}
			if { $egresult != 0 } then {		
# we have tried and there is no register there !
				midas-warning " There is no Logic Analyser in this Resource Manager \n"
		                set EGallow $egallowstore	
				register-undefine 0
				return
			}
			set EGallow $egallowstore		
# there is a Logic Analyser
			for {set i 1} {$i <= $reglisttotal} {incr i} {
				register-define $i		
# define the registers in turn
				register-set-attributes $i	
# set the attributes, and then initialise them ?
			}
		}
		set EGallow $egallowstore
# if the rmla is in the reset state then clear the reset, and set it up with position 7 , and ft true.
#	reset-test
}

proc reset-test {} {
	if { [read-vxi-reg LA.Reset ] } then {
		click-reset
		write-vxi-reg LA.Trig.Place 15
		write-vxi-reg LA.Trig.Pattern 0x40
		write-vxi-reg LA.Trig.DontCare 0xbf

	}
}

# should only get this far if there is a Logic Analyser , and the registers are valid.
#-------------------------------------------------------------------------------------------
# back to the origional code
#                     proc      register           args
# These are the bits of the trigger word. 0,1,x are the valid states.
set table(VALID1)      {click-trig   Val1            {}}
set table(INHREQ)      {click-trig   InhibitRequest  {}}
set table(LOGINSP0)    {click-trig   Insp.D1         {}}
set table(LOGINSP1)    {click-trig   Insp.D2         {}}
set table(VALID3)      {click-trig   Val3            {}}
set table(INHACT)      {click-trig   InhibitAction   {}}
set table(FASTTRIG)    {click-trig   FT 	     {}}
set table(EXTERNAL)    {click-trig   Ext             {}}
set table(POSN)        {click-cont   Position        {}}
set table(PLACE)       {click-place  Place 	     {}}
#
#                               proc            widgets                args
#
set table(Trig.Val1)          {update-trig    VALID1      {}}
set table(Trig.InhibitRequest) {update-trig    INHREQ      {}}
set table(Trig.Insp.D1)       {update-trig    LOGINSP0    {}}
set table(Trig.Insp.D2)       {update-trig    LOGINSP1    {}}
set table(Trig.Val3)          {update-trig    VALID3      {}}
set table(Trig.InhibitAction) {update-trig    INHACT      {}}
set table(Trig.FT)            {update-trig    FASTTRIG    {}}
set table(Trig.Ext)           {update-trig    EXTERNAL    {}}
# don't care flags
set table(Trig.X.Val1)          {update-xreg    VALID1      {}}
set table(Trig.X.InhibitRequest) {update-xreg    INHREQ      {}}
set table(Trig.X.Insp.D1)       {update-xreg    LOGINSP0    {}}
set table(Trig.X.Insp.D2)       {update-xreg    LOGINSP1    {}}
set table(Trig.X.Val3)          {update-xreg    VALID3      {}}
set table(Trig.X.InhibitAction) {update-xreg    INHACT      {}}
set table(Trig.X.FT)            {update-xreg    FASTTRIG    {}}
set table(Trig.X.Ext)           {update-xreg    EXTERNAL    {}}
# status bits
set table(Run)           	{update-state    RUN        {}}
set table(FIFO.Empty)           {update-state    FIFOEMPTY  {}}
set table(FIFO.Full)            {update-state    FIFOFULL   {}}
set table(Int.Enable)        	{update-state    INTENA     {}}
set table(Reset)       		{update-state    RESETOUT   {}}
set table(Triggered)       	{update-state    TRIGGERED  {}}
# the new place slider
set table(Trig.Place)		{update-place	PLACE {} }
# these are for safety, not used yet.
set table(Trig.Position) 	{update-nop    XXXX       {}}
set table(Trig.DontCare) 	{update-nop    XXXX       {}}
set table(Trig.Pattern) 	{update-nop    XXXX       {}}
set table(Readout) 		{update-nop    XXXX       {}}
set table(Trace0) 		{update-nop    XXXX       {}}
set table(Trace1) 		{update-nop    XXXX       {}}
set table(Trace2) 		{update-nop    XXXX       {}}
set table(Trace3) 		{update-nop    XXXX       {}}
set table(Trace4) 		{update-nop    XXXX       {}}
set table(Trace5) 		{update-nop    XXXX       {}}
set table(Trace6) 		{update-nop    XXXX       {}}
set table(Trace7) 		{update-nop    XXXX       {}}


proc read-insp {ln} {
	global chanindex chanlist
	set chan [lindex $chanlist $chanindex]
        set vxicrate [VXImodule2crate RM$chan]
	set reg "/$vxicrate/NetVar_Inspection_DI$ln"
	EG "register :name '$reg' ?value"
}

proc update-trig {w v a} {
	global debug table
	set table($w) [lreplace $table($w) 2 end $v]
	if {$debug} then { insert-debug "put $v into the table for $w" }
}

# here after updating the trigger state, so if nothing to update , don't!
proc update-xreg {w v a} {
	global table	
	if {[scan-int $v]} then {:modify $w :value 2}  \
	  else { :modify $w :value [third $table($w)]}
}

proc update-state {w v a} {:modify $w :value [scan-int $v]}

proc update-place {w v a} {:modify $w :value [expr { 16 - [ expr {  [scan-int $v] & 15 }]} ] }

proc update-nop {w v a} {}


proc update-pair {p} {
	global debug table

	if {$debug} then {insert-debug $p}
# ignore the RM1.LA
	set reg [strip-to-dot [strip-to-dot [first $p]]]     
	set val [second $p]
#	catch {
		set func   [first  $table($reg)]
		set widget [second $table($reg)]
		set arg    [third  $table($reg)]
#insert-debug "$func $widget $val $arg"
		$func $widget $val $arg
#	}
}

proc test-triggered {} {
	global debug afterid
	if {[read-vxi-reg LA.Triggered ] } then  {
			write-vxi-reg LA.Run 0
			click-la-update
			:modify WAITING :value 0
			click-redisplay
	        } \
	else	{
		set afterid [ after 10000 test-triggered ]
	}
}


proc click-reset {} {
	write-vxi-reg LA.Reset 1
	write-vxi-reg LA.Reset 0
	click-redisplay
}

proc click-start v {
	global afterid
	write-vxi-reg LA.Run $v
	:modify WAITING :value $v
	if { $v == 0 } then {
		after cancel $afterid
	}
	if { $v == 1 } then {
		test-triggered
	}
	click-redisplay
}

proc Run {} {
   global RunState RunMode RunPeriod
   global EGreport

   set EGreport -1
  
     if {$RunMode == 1 && $RunState == 0} then {
#    start it running
	write-vxi-reg LA.Run 1
        set RunState 1
     }

#    test if triggered
     if {[read-vxi-reg LA.Triggered ] == 1} then {
        write-vxi-reg LA.Run 0
        set RunState 0
        write-vxi-reg LA.Readout "Fred"
        if {$RunMode == 1} then {inform rmladisp do-refresh}
     }
     
     if {$RunMode == 1} then {
         after $RunPeriod Run
     } else {
        write-vxi-reg LA.Run 0
        set RunState 0
     }

   set EGreport 0
}

proc click-cont {r v a} {write-vxi-reg LA.Trig.$r [expr {$v & 1}]} 

proc click-place {r v a} {write-vxi-reg LA.Trig.$r [expr { 16 - [expr {$v & 15}]} ]}

proc click-trig {r v a} {
	write-vxi-reg LA.Trig.X.$r [expr {($v>>1) & 1}]
	write-vxi-reg LA.Trig.$r   [expr {$v & 1}] 
}

proc click-on {w v} {
	global debug table  

	if {$debug} then {insert-debug "click on $w $v"}
	set func [first $table($w)]
	set reg  [second $table($w)]
	set arg  [third $table($w)]

	$func $reg $v $arg
	click-redisplay
}

proc click-redisplay {} {
	global debug  chanlist chanindex fwprogname
        global ladfinsp0 ladfinsp1
	check-for-rmla
	set list [read-vxi-regs LA.*]
	catch {:modify CHANNEL :value $chanindex}
	foreach pair $list {update-pair $pair}
	set ladfinsp0 [ read-insp 1]
	set ladfinsp1 [ read-insp 2]
#	update-inspection
	:modify DATA-FILE :value "$fwprogname"
	:modify INSP0     :label "$ladfinsp0"
	:modify INSP1     :label "$ladfinsp1"
}

proc click-la-update {} {
	global chanindex chanlist
	set chan [lindex $chanlist $chanindex]
	catch {write-vxi-reg LA.Readout "Fred"}
        inform rmladisp set RMchan $chan
	inform rmladisp do-update
}
            
proc click-ladf-redisplay {} {
   global fwdirname fwprogname debug
   :modify FWDIR       :value "$fwdirname"
   :modify FWPROG      :value "$fwprogname"
   :modify DATA-FILE   :value "$fwprogname"
   fw-paint-directory
}

proc click-ladf {} {
   global ladfvisible ladfframe

   if {$ladfvisible==0} then {make-ladfframe} else {open-frame $ladfframe}
   click-ladf-redisplay
}   


proc click arg {
   global debug RunMode
   if {$debug} then {insert-debug "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit $f ; return }
   switch $w  {
      CHANNEL   {click-channel $v}
      REDISPLAY {click-redisplay}
      RESET     {check-for-rmla; click-reset}
      GO        {check-for-rmla; click-start 1}
      STOP      {check-for-rmla; set RunMode 0; click-start 0}
      RUNC      {check-for-rmla; set-footer "Started continuous update"; set RunMode 1; Run}
      HELP      {click-help}
      LADF	{click-ladf}
      LAUPD     {click-la-update}
      LADF-REDISPLAY	{click-ladf-redisplay }
      FWDIR	        {click-fw-dirname $v}
      FWPROG		{click-fw-progname $v}
      FWLIST		{click-fw-list $c $v; click-ladf-redisplay}
      default   {click-on $w $v}
   }
}

proc make-frame {} {
  global env
  global bits chanlist posnlist fwprogname ladfinsp0 ladfinsp1

set col1 20c
set col2 12c

 :frame [self frame-name] :label "[self frame-title]" :resize F :show-footer T \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]"

     :panel P1 :layout T :padx 5 :pady 5
       :layout H; :row-gap 5
	:choice-stack CHANNEL :label RMp: :strings $chanlist :valuex $col1
     	:text DATA-FILE  :label File: :w 20 :read-only T :valuex 20c :value "$fwprogname"

     :panel P2 :layout L :padx 5 :pady 5
       :layout V; :row-gap 5
	:message M1 :label "Trigger setup"  :bold T  :valuex 20c
#	:choice POSN :strings $posnlist :label "Trigger Position:" :exclusive T  :valuex $col1
	:choice  FASTTRIG :strings $bits :label "Fast Trigger:" :exclusive T :valuex $col1
	:choice  VALID3 :strings $bits :label "Validation 3:" :exclusive T :valuex $col1
	:choice  LOGINSP0 :strings $bits :label "Digital Inspection 1:" :exclusive T :valuex $col1
        :layout H
     	:message INSP0 :label ""  
#	:message MUX-DI1-USE :label ""
        :next-row T
	:choice  LOGINSP1 :strings  $bits :label "Digital Inspection 2:" :exclusive T :valuex $col1
     	:message INSP1 :label ""   
#	:message MUX-DI2-USE :label ""
        :next-row T
        :layout V
	:choice  EXTERNAL :strings $bits :label External: :exclusive T  :valuex $col1
	:choice  INHREQ :strings $bits :label "Inhibit Request:" :exclusive T  :valuex $col1
        :layout H
	:hskip 90
	:checkbox WAITING   :label "Waiting for Trigger:" :deaf T 
        :next-row T
        :layout V

	:choice  INHACT :strings $bits :label "Inhibit Action:" :exclusive T :valuex $col1
	:choice  VALID1 :strings $bits :label "Validation 1:" :exclusive T :valuex $col1 
	:layout H
	:hskip 20 
	:slider PLACE :label "Place" :min 1 :max 15 :resolution 1
        :message DUMMY :label "            "


     :panel P3 :layout R :padx 5 :pady 5
       :layout V; :row-gap 5
	:message M2         :label "LA Status" :bold T
	:checkbox INTENA    :label Interrupts: :deaf F :valuex $col2
	:checkbox RUN       :label Run: :deaf T :valuex $col2
	:checkbox RESETOUT  :label Reset: :deaf T :valuex $col2
	:checkbox FIFOFULL  :label "FIFO Full:" :deaf T :valuex $col2
	:checkbox FIFOEMPTY :label "FIFO Empty:" :deaf T :valuex $col2
	:checkbox TRIGGERED :label Triggered: :deaf T :valuex $col2
        :vskip 20
	:button LAUPD     :label "View data"

     :panel P4 :layout B :padx 5 :pady 5 :after FOOTER
       :layout H; :col-gap 5

	:button REDISPLAY :label Redisplay
	:button RESET     :label Reset
	:button GO        :label Go
	:button STOP      :label Stop
	:button RUNC      :label "Run Continuous"
        :button SETUP     :label "ReCreate Registers" :command check-for-rmla
        :hskip 80
	:button HELP

    :show T
}

# this is the sub-window for picking the data file for storage of the LA output.

set ladfframe [self frame-name].ladf
set ladfvisible 0
set fwdirname "$env(EXPBASE)/la-readout"
set fwprogname ""

proc make-ladfframe {} {
  global env ladfframe ladfvisible fwdirname fwprogname

 :frame $ladfframe :label "RM Logic Analyser data file" :show-footer T :resize F  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]ladf"

 wm protocol $ladfframe \
     WM_DELETE_WINDOW {global ladfvisible; set ladfvisible 0; destroy $ladfframe}

   :panel P1 :layout L :padx 5 :pady 5
   :layout H; :row-gap 10
   :text FWDIR :label Directory: :w 20 :value "$fwdirname" :valuex 12c
   :next-row T
   :text FWPROG :label File: :w 20  :value "$fwprogname" :valuex 12c

   :panel P3 :layout B :padx 5  :after FOOTER
   :layout H; :row-gap 10
   :button LADF-REDISPLAY :label Redisplay
   :hskip 80
   :button LADF-HELP      :label Help...

   :panel P2 :layout L :padx 5 :pady 5
   :list FWLIST :rows 10 :cols 20

   :show T

  set ladfvisible 1
}


proc start args {
   global started chanindex chanlist
   if {$started == 0} then  {
     	 set started 1
    	 set chanindex [inform rm set chanindex]
   	 set chanlist [inform rm set chanlist]
    	 make-frame
     	 click-redisplay
	 reset-test
    	 inform rmladisp start
   } else {open-frame} 

   make-chanlist
   make-myserver
   reset-test
  click-redisplay
}

