# slotone module frame
#    6 june 2001   VP

set debug 0
set started 0

set frame SLOTONE
set frametitle "SlotOne Module Control"
set icontitle SlotOne


set cardtype SlotOne
set chantype ""

set chanlist {???}
set chanindex 0

set defaultchanlist {0 1 2 3}

set rname(MODELCODE)   VXI.ModelCode
set rname(SERIALNUM)   VXI.SerialNum 
set rname(MODLEVEL)    VXI.ModLevel
set rname(MANID)       VXI.ManID

set rname(RENO)        RENO
set rname(VXI-ENABLE)  VXI.Enable
set rname(VXI-GO)      VXI.Go
set rname(VXI-INHIBIT) VXI.Inhibit
set rname(SXFER)       Scalers.Xfer
set rname(FPTTLTRG)    EnableFPTTLTRG

set rname(INTR)        InterruptPresent
set rname(ADC)         ADC
set rname(BUSY)        ADCBusy
set rname(TTLTRG)      TTLTRG
set rname(ECLTRG)      ECLTRG

for {set sid [array startsearch rname]} {[array anymore rname $sid]} { } {
	set element [array nextelement rname $sid]
	set wname($rname($element)) $element
	set r2v($element) scan-int
}

set r2v(MODELCODE) quote-text
set r2v(SERIALNUM) quote-text
set r2v(MODLEVEL)  quote-text
set r2v(MANID)     quote-text

loadsource common.vxi

  
proc click-on {w v} {
	global rname
	clear-footer
	set register $rname($w)
	write-vxi-reg $register $v
	click-redisplay
}

proc click arg {
	global debug 
	if {$debug} then {puts stderr "click with argument \{$arg\}"}
	set f [lindex $arg 0]
	set c [lindex $arg 1]
	set w [lindex $arg 2]
	set v [lindex $arg 3]
	if {$c==":quit"} then {click-quit $f; return}
	switch $w  {
		CHANNEL      {click-channel $v}
		REDISPLAY    {click-redisplay}
                ENGINEERING  {click-$v}
		default      {click-on $w $v}
	}
}

proc make-frame1 {} {
  global env chanlist chanindex

  :frame [self frame-name] :label "[self frame-title]" :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" :resize F

  :panel PANEL :layout T :padx 10 :pady 10
    :layout H; :col-gap 10; :row-gap 10

     :choice-stack CHANNEL :label "Module:"  :valuex 12c :strings $chanlist :value $chanindex
     :text MODELCODE       :label "Model Code:"    :w 6 :read-only T :valuex 14c
   :next-row T
      :checkbox RENO :label RENO: :valuex 12c
      :text SERIALNUM       :label "Serial Number:" :w 6 :read-only T :valuex 22c
   :next-row T
      :checkbox SXFER :label "Xfer Scalers:" :valuex 12c
      :text MODLEVEL :label "Modification Level:"   :w 6 :read-only T :valuex 22c
   :next-row T
      :checkbox FPTTLTRG :label "FP TTLTRG:" :valuex 12c :deaf T
      :text MANID  :label "Manufacturer ID:" :w 6 :read-only T :valuex 22c
   :next-row T
      :choice VXI-ENABLE :label VXI: :strings [list Disable Enable]
      :choice VXI-GO :strings [list Stop Go]
      :choice VXI-INHIBIT :strings [list "Inhibit Request"] :exclusive F
   :next-row T
      :text ADC-TEXT :label ADC: :w 8 :read-only T
      :gauge ADC :label "" :min -5000 :max 5000 :ticks 11
      :choice BUSY :strings [list Busy] :exclusive F :deaf T
      :choice INTR :strings [list "Interrupt"] 
   :next-row T
      :hskip 50
      :choice ECLTRG  :label ECLTRG: :exclusive F :valuex 10c :deaf T :layout V :w 16 \
		:strings [list "Validation 1" "Synch Trig" "Inhibit Request" "Digital Insp 1" \
		          "Digital Insp 2" "Validation 2"]
      :choice TTLTRG  :label TTLTRG: :exclusive F :valuex 10c :deaf T :layout V :w 16 \
		:strings [list Coding Readout "Xfer Scalers" Clear  \
		          "VXI Go" "Reject Event" "Validation 3" "Inhibit Action"]
   :next-row T
      :button REDISPLAY
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics software]
      :button HELP

   :show T
}


proc make-electronics {} {
  global electronicsvisible

  :frame [self frame-name].electronics :label "SlotOne Electronics" :resize F :transient T

   :panel P20 :layout T :padx 5 :pady 5
      :layout V; :row-gap 10
      :checkbox LASTCARD  :label "Last Card:"                            :valuex 20c
      :text MODELCODE     :label "Model Code:" :w 6  :read-only T        :valuex 20c
      :text SERIALNUM     :label "Serial Number:" :w 6 :read-only T      :valuex 20c
      :text MODLEVEL      :label "Modification Level:" :w 6 :read-only T :valuex 20c
      :text MANID         :label "Manufacturer ID:" :w 6  :read-only T   :valuex 20c
    
  :show T
 set electronicsvisible 1
}


