

#   vre.defn.tcl     VXI Readout Engine


proc {AddVREModule}  {module slot}  {
   global registerbase cardtype nsockets

   set registerbase $cardtype$module

   delete-vxi-registers $registerbase.*

   VREVXIRegisters $slot
   VREModuleRegisters $slot
}

proc vre_register {registername class attributes} {
   global registerbase
   define-vxi-register $registerbase $class $registername "$attributes"
}

proc VREVXIRegisters {slot} {
   vre_register  VXI.ManID      xSht   "-s$slot -o0  -pro -w16 -fx -b0  -l12"
   vre_register  VXI.AddrSpace  xSht   "-s$slot -o0  -pro -w16 -fd -b12 -l2"
   vre_register  VXI.DevClass   xSht   "-s$slot -o0  -pro -w16 -fd -b14 -l2"
   vre_register  VXI.ModelCode  xSht   "-s$slot -o2  -pro -w16 -fx -b0  -l12"
   vre_register  VXI.ReqMem     xSht   "-s$slot -o2  -pro -w16 -fd -b12 -l4"
   vre_register  VXI.Reset      xSht   "-s$slot -o4  -prw -w16 -fd -b0  -l1"
   vre_register  VXI.Passed     xSht   "-s$slot -o4  -pro -w16 -fd -b2  -l1"
   vre_register  VXI.Ready      xSht   "-s$slot -o4  -pro -w16 -fd -b3  -l1"
   vre_register  VXI.ModID      xSht   "-s$slot -o4  -pro -w16 -fd -b14 -l1"
   vre_register  VXI.A24A32     xSht   "-s$slot -o4  -pro -w16 -fd -b15 -l1"
   vre_register  VXI.Offset     xSht   "-s$slot -o6  -pro -w16 -fx"
   vre_register  VXI.SerialNum  xSht   "-s$slot -o8  -pro -w16 -fx"
   vre_register  VXI.ModLevel   xSht   "-s$slot -o10 -pro -w16 -fx"
}

proc VREModuleRegisters {slot} {

        vre_register   VXI.Address     xAddress  "-s$slot"
        vre_register   VXI.DataAccess  bVXI      "-s$slot -a0x0 -o0x0 -w32 -prw -fx"

	vre_register   Status                   xSht "-s$slot -o0x20 -pro -w16 -fx"
	vre_register   Status.VXI.NewMail       xSht "-s$slot -o0x20 -pro -w16 -fd -b8 -l1"
	vre_register   Status.VXI.NotReadMail   xSht "-s$slot -o0x20 -pro -w16 -fd -b11 -l1"
	vre_register   LCA.Version.Year         xSht "-s$slot -o0x22 -pro -w16 -fd -b4 -l4"
	vre_register   LCA.Version.Week         xSht "-s$slot -o0x22 -pro -w16 -fd -b8 -l8"
	vre_register   DPM.Size                 xSht "-s$slot -o0x22 -pro -w16 -fd -b0 -l2"
	vre_register   IRQ.Enb                  xSht "-s$slot -o0x26 -prw -w16 -fd -b11 -l1"
	vre_register   IRQ.Level                xSht "-s$slot -o0x26 -prw -w16 -fx -b8 -l3"
	vre_register   IRQ.ID                   xSht "-s$slot -o0x26 -prw -w16 -fx -b0 -l8"
	vre_register   Mail.ToDSP               xSht "-s$slot -o0x24 -pwo -w16 -fx"
	vre_register   Mail.FromDSP             xSht "-s$slot -o0x24 -pro -w16 -fx"

	vre_register   Start_Token              xDig "-s$slot -a0x1c000 -o0x54 -prw -w32 -fx"
	vre_register   Event_TokenL             xDig "-s$slot -a0x1c000 -o0x58 -prw -w32 -fx"
	vre_register   Event_TokenH             xDig "-s$slot -a0x1c000 -o0x5c -prw -w32 -fx"
	vre_register   End_Token                xDig "-s$slot -a0x1c000 -o0x60 -prw -w32 -fx"

	vre_register   Enables                  xDig "-s$slot -a0x1c000 -o0x64 -prw -w32 -fx -i0"
	vre_register   Enable_VXI               xDig "-s$slot -a0x1c000 -o0x64 -prw -w32 -fd -b0 -l1 -i1"
	vre_register   Enable_DT32              xDig "-s$slot -a0x1c000 -o0x64 -prw -w32 -fd -b1 -l1 -i1"
	vre_register   Enable_EvNumL            xDig "-s$slot -a0x1c000 -o0x64 -prw -w32 -fd -b2 -l1 -i1"
	vre_register   Enable_EvNumH            xDig "-s$slot -a0x1c000 -o0x64 -prw -w32 -fd -b3 -l1 -i1"

	vre_register   ROErrors.Scaler          xDig "-s$slot -a0x1c000 -o0x68 -prw -w32 -fd -i0"
	vre_register   Val.Scaler               xDig "-s$slot -a0x1c000 -o0x6c -prw -w32 -fd -i0"
	vre_register   EvNum                    xDig "-s$slot -a0x1c000 -o0x70 -prw -w32 -fd -i0"

	vre_register   DiagMode                 xDig "-s$slot -a0x1c000 -o0xb4 -pro -w32 -fx"

	vre_register   CtrlRAM                  xDig "-s$slot -a0x1c000 -o0x00 -pro -w32 -fx"
	vre_register   DataRAM                  xDig "-s$slot -a0x400000 -o0x00 -prw -w32 -fx"

	vre_register   CtrlRAM.DataAccess       bVXI "-s$slot -a0x1c000 -o0x00 -pro -w32 -fx"
	vre_register   ScalerRAM.DataAccess     bVXI "-s$slot -a0x1f000 -o0x00 -prw -w32 -fx -l64 -i0"
	vre_register   DataRAM.DataAccess       bVXI "-s$slot -a0x400000 -o0x00 -prw -w32 -fx"

	vre_register   RptCount1                xDig "-s$slot -a0x402004 -o0x00 -prw -w32 -fx"
	vre_register   RptCount2                xDig "-s$slot -a0x402008 -o0x00 -prw -w32 -fx"
	vre_register   RptCount3                xDig "-s$slot -a0x40200c -o0x00 -prw -w32 -fx"
	vre_register   RptCount4                xDig "-s$slot -a0x402010 -o0x00 -prw -w32 -fx"
	vre_register   RptCount5                xDig "-s$slot -a0x402014 -o0x00 -prw -w32 -fx"

	vre_register   DiagBuf1                 xDig "-s$slot -a0x402400 -o0x00 -prw -w32 -fx"
	vre_register   DiagBuf2                 xDig "-s$slot -a0x402800 -o0x00 -prw -w32 -fx"
	vre_register   DiagBuf3                 xDig "-s$slot -a0x402c00 -o0x00 -prw -w32 -fx"
	vre_register   DiagBuf4                 xDig "-s$slot -a0x403000 -o0x00 -prw -w32 -fx"
	vre_register   DiagBuf5                 xDig "-s$slot -a0x403400 -o0x00 -prw -w32 -fx"

	vre_register   DiagBuf1.DataAccess      bVXI "-s$slot -a0x402400 -o0x00 -prw -w32 -fx"
	vre_register   DiagBuf2.DataAccess      bVXI "-s$slot -a0x402800 -o0x00 -prw -w32 -fx"
	vre_register   DiagBuf3.DataAccess      bVXI "-s$slot -a0x402c00 -o0x00 -prw -w32 -fx"
	vre_register   DiagBuf4.DataAccess      bVXI "-s$slot -a0x403000 -o0x00 -prw -w32 -fx"
	vre_register   DiagBuf5.DataAccess      bVXI "-s$slot -a0x403400 -o0x00 -prw -w32 -fx"

	vre_register   Control.DSPrun           xBsr "-s$slot -c0 -o0x20 -prw -w16 -va16 -x12 -y4 -z12 -i0"
	vre_register   Control.Mbox.IRQ.Enb     xBsr "-s$slot -c0 -o0x20 -prw -w16 -va16 -x7 -y15 -z7 -i0"
	vre_register   Control.FIFO.Clrmode     xBsr "-s$slot -c0 -o0x20 -prw -w16 -va16 -x6 -y14 -z6 -i0"
	vre_register   Control.FIFO.Clrenb      xBsr "-s$slot -c0 -o0x20 -prw -w16 -va16 -x5 -y13 -z5 -i0"

	vre_register   DSPFile                  xDSP "-s$slot -o0"
}


proc VRE_DAQ-reset   {args}   {
   set module [first $args]
}

proc VRE_DAQ-halt   {args}   {
   set module [first $args]
#    no action
}

proc VRE_DAQ-go   {args}   {
   set module [first $args]
}
